import { jsx as i, Fragment as fe, jsxs as F } from "react/jsx-runtime";
import * as B from "react";
import { useRef as H, useEffect as W, useCallback as N, useState as $, useMemo as k, createContext as Ye, useContext as Je, forwardRef as $e, useImperativeHandle as cn, createElement as qe, PureComponent as Qn, Component as er, memo as ln } from "react";
import { ChevronUpIcon as He } from "./components/icons/ChevronUpIcon.js";
import { UIButton as re } from "./components/ui/Button.js";
import { UIInput as dn } from "./components/ui/Input.js";
import { ViewMode as xe, ScrollMode as J, AnnotationSubType as zt, SelectionMode as tr, ZoomLevel as at } from "./utils/types.js";
import { useScrollModeContext as Re } from "./contexts/ScrollModeContext.js";
import { useDocumentContext as Q } from "./contexts/RPDocumentContext.js";
import { useDocumentPasswordContext as nr } from "./contexts/DocumentPasswordContext.js";
import { useDarkModeContext as rr } from "./contexts/DarkModeContext.js";
import { useRotationContext as Ge } from "./contexts/RotationContext.js";
import { useLayerContext as or } from "./contexts/LayerContext.js";
import { useZoomContext as Qe } from "./contexts/ZoomContext.js";
import { useViewModeContext as Ee } from "./contexts/ViewModeContext.js";
import { useVirtualScrollContext as et } from "./contexts/VirtualScrollContext.js";
import { useVirtualGridContext as un } from "./contexts/VirtualGridContext.js";
import { useSelectionModeContext as ir } from "./contexts/SelectionModeContext.js";
import { useInitialStateContext as ar } from "./contexts/InitialStateContext.js";
import { useFullScreenContext as sr } from "./contexts/FullScreenContext.js";
import "./contexts/FileInputContext.js";
import "./contexts/DropFileZoneContext.js";
import { renderPage as vt } from "./utils/renderPage.js";
import { findMatches as cr, resetDivs as lr, highlightMatches as dr, isMatchEntireWord as ur } from "./utils/highlight.js";
import { useLayoutContainer as ge } from "./contexts/LayoutContainerContext.js";
import { useDimensionPagesContext as Ue } from "./contexts/DimensionPagesContext.js";
import { useLocalizationContext as se } from "./contexts/LocalizationContext.js";
import { useHighlightContext as pr } from "./contexts/HighlightContext.js";
import "./contexts/LicenseContext.js";
import { useDownloadContext as hr } from "./contexts/DownloadContext.js";
import { useSmoothScrollContext as pn } from "./contexts/SmoothScrollContext.js";
import { useLoaderContext as hn } from "./contexts/LoaderContext.js";
import "./components/RPConfig.js";
import { ThumbnailIcon as mr } from "./components/icons/Thumbnail.js";
import { c as ne } from "./clsx-0c6e471a.js";
import { LoaderIcon as Ct } from "./components/icons/LoaderIcon.js";
import { useInfiniteScroll as fr } from "./utils/hooks/useInfiniteScroll.js";
import { RPSplitter as gr } from "./components/layout/sidebar/RPSplitter.js";
import { useToolbarComponentContext as ve, ToolbarComponentProvider as vr } from "./contexts/ToolbarComponentContext.js";
import { useIconContext as pe, IconProvider as wr } from "./contexts/IconContext.js";
import K from "./components/ui/RPTooltip.js";
import { Container as _r } from "./components/layout/Container.js";
import { WrapperLayout as br } from "./components/layout/WrapperLayout.js";
import { RPDropFileZone as Cr } from "./components/RPDropFileZone.js";
import { useViewportContext as Ce, ViewportProvider as Pr } from "./contexts/ViewportContext.js";
import { useThemeContext as Tr } from "./contexts/ThemeContext.js";
import * as Sr from "pdfjs-dist";
import { PixelsPerInch as yr, AnnotationMode as Ir, RenderingCancelledException as xr, AnnotationLayer as Lr } from "pdfjs-dist";
import { SimpleLinkService as Rr } from "./utils/link_service.js";
import { annotationsEvents as Er, annotationEventsHandler as Nr, handleClick as At, handleAnnotationWidget as Or, handleAnnotationLink as Dr, bindLayerEvents as zr, unbindLayerEvents as Ft } from "./utils/annotations.js";
import { normalizeSingleKeyword as Ar, sortHighlightPosition as Fr, unwrap as Wr } from "./components/page/searchHighlight.js";
import { _ as kr, U as Mr } from "./Popover-b7402893.js";
import { useMousePressed as Hr } from "./utils/hooks/useMousePressed.js";
import { useGrabScroll as $r } from "./utils/hooks/useGrabScroll.js";
import { usePinch as Gr } from "./utils/hooks/usePinch.js";
import { useDebounce as Pt } from "./utils/hooks/useDebounce.js";
import Ur from "./components/ui/PasswordModal.js";
import { getPositionFromPage as Vr, getPageFromPosition as qr } from "./utils/calculatePage.js";
import { getScrollDistance as Ae } from "./utils/getScrollDistance.js";
import { getWordPositionInPage as Br } from "./utils/getWordPositionInPage.js";
import { getThumbnailViewport as Wt } from "./utils/getThumbnailViewport.js";
import { smoothScrollTo as st } from "./utils/smoothScrollTo.js";
import { appConsole as Zr } from "./utils/appConsole.js";
import { FileUploadTool as mn } from "./components/layout/toolbar/FileUploadTool.js";
import { DarkModeTool as jr } from "./components/layout/toolbar/DarkModeTool.js";
import { ThreeDotIcon as Kr } from "./components/icons/ThreeDotIcon.js";
import { UIDropDown as fn } from "./components/ui/DropDown.js";
import { e as Xr, a as Tt, P as Ve, c as Me, g as St, i as Yr, k as Jr, f as Qr } from "./index-1cb41342.js";
import { D as eo, u as ct } from "./index-aa2d3884.js";
import { a as to, u as no, F as ro, b as oo, G as Ke } from "./index-7279fb4e.js";
import { h as io } from "./component-1da194e8.js";
import { CloseIcon as ao } from "./components/icons/CloseIcon.js";
import { dateFormatter as kt } from "./utils/dateFormatter.js";
import { PropertyItem as so } from "./components/layout/toolbar/PropertyItem.js";
import { useOtherToolContext as co, OtherToolProvider as lo } from "./contexts/OtherToolContext.js";
import { DocumentProperties as uo } from "./components/layout/toolbar/DocumentProperties.js";
import { RotateTool as po } from "./components/layout/toolbar/RotateTool.js";
import { ViewModeTool as ho } from "./components/layout/toolbar/ViewModeTool.js";
import { ScrollModeTool as mo } from "./components/layout/toolbar/ScrollModeTool.js";
import { MenuSeparator as yt } from "./components/layout/toolbar/MenuSeparator.js";
import { FileDownloadDefaultIcon as fo } from "./components/icons/FileDownloadDefaultIcon.js";
import { MenuItem as be } from "./components/layout/toolbar/MenuItem.js";
import { PrintDefaultTool as go } from "./components/icons/PrintDefaultIcon.js";
import { FullScreenTool as gn } from "./components/layout/toolbar/FullScreenTool.js";
import { GoToDownIcon as vn } from "./components/icons/GoToDownIcon.js";
import { SelectionModeTool as vo } from "./components/layout/toolbar/SelectionModeTool.js";
import { ZoomInIcon as wo } from "./components/icons/ZoomInIcon.js";
import { ZoomOutIcon as _o } from "./components/icons/ZoomOutIcon.js";
import { PAGE_PADDING as Mt } from "./utils/constants.js";
import { getZoomLevel as bo } from "./utils/getZoomLevel.js";
import { SearchIcon as Co } from "./components/icons/SearchIcon.js";
import { c as Y, S as Ht } from "./SearchCloseButton-ddb9877e.js";
import { UICheckbox as $t } from "./components/ui/Checkbox.js";
import { ClearIcon as Po } from "./components/icons/ClearIcon.js";
import { InfoIcon as Gt } from "./components/icons/InfoIcon.js";
import './assets/RPDefaultLayout.css';const wn = () => {
  const { viewMode: t } = Ee(), { scrollMode: e } = Re(), { virtualScrollRef: n, virtualScrollableElementRef: o, pageScrollElementRef: r } = et(), { setFocusedPage: a } = ie(), l = H(), { columnCount: c } = un(), { widths: d, heights: p } = Ue(), f = H(e), _ = H(t), h = H(c), { targetScrollPage: v } = pn();
  W(() => {
    n != null && n.scrollToItem && (l.current = n);
  }, [n]), W(() => {
    f.current = e, _.current = t;
  }, [e, t]);
  const w = N(
    (P, S) => {
      if (!r)
        return;
      const u = Math.ceil(P / 2) * 2 - 1;
      if (P === u + 1) {
        const g = {
          left: d[u],
          top: 0
        };
        return new Promise(
          (s) => st(r, g, s)
        );
      }
      const m = {
        left: 0,
        top: 0
      };
      return r == null ? void 0 : r.scrollTo({
        ...m,
        behavior: S
      });
    },
    [r, d, st]
  );
  return W(() => {
    f.current = e, _.current = t;
  }, [e, t]), W(() => {
    h.current = c;
  }, [c]), { scrollToPage: N(
    (P, S = "smooth") => {
      a(P);
      const u = P - 1;
      let m = u, g = 0;
      if (_.current === xe.DUAL_PAGE && f.current === J.PAGE_SCROLLING) {
        w(P, S);
        return;
      }
      if (f.current === J.PAGE_SCROLLING) {
        a(P);
        return;
      }
      if (!l.current || !o)
        return;
      const s = o;
      if (v.current = P, f.current === J.HORIZONTAL_SCROLLING) {
        g = u;
        const y = {
          left: Ae(d, g),
          top: 0
        };
        return s.scrollTo({
          ...y,
          behavior: S
        });
      }
      if (_.current === xe.DUAL_PAGE) {
        g = u % 2, m = Math.floor(u / 2);
        const y = {
          left: Ae(d, g),
          top: Ae(p, m)
        };
        return s.scrollTo({
          ...y,
          behavior: S
        });
      }
      const C = {
        left: 0,
        top: Ae(p, m)
      };
      return s.scrollTo({
        ...C,
        behavior: S
      });
    },
    [
      o,
      c,
      w,
      a,
      st,
      p,
      d
    ]
  ) };
}, To = (t = 1) => {
  const [e, n] = $(t), [o, r] = $(0), { scrollToPage: a } = wn(), l = H(1), { viewMode: c } = Ee(), { scrollMode: d } = Re(), { widths: p } = Ue(), { pagesRef: f } = ge(), _ = Pt(e, 100), h = N(
    (m) => {
      if (!/^[0-9]*$/g.test(m.toString()) || !m)
        return { success: !1, currentPage: l.current };
      const s = +m;
      return s < 0 || s > o ? { success: !1, currentPage: l.current } : (n(s), l.current = s, { success: !0, currentPage: +m });
    },
    [o]
  ), v = N(h, [h]), w = N(
    (m) => {
      const g = h(m);
      return g.success && a(g.currentPage), g;
    },
    [h, a]
  ), T = N((m) => {
    const g = m % 2 === 1;
    if (!f || g)
      return !1;
    const s = g ? p[m] : p[m - 1], C = g ? p[m + 1] : p[m];
    return c === xe.DUAL_PAGE && s + C < f.clientWidth;
  }, [c, p, f, o]), P = N(() => {
    let m = e - 1;
    T(m) && (m = e - 2), w(m);
  }, [w, e, c, d, T]), S = k(() => c === xe.DUAL_PAGE && d === J.PAGE_SCROLLING ? e === o - 1 : e === o, [e, o, c, d]), u = N(() => {
    if (S)
      return;
    let m = e + 1;
    T(m) && (m = e + 2), w(m);
  }, [w, e, T, c, d, S]);
  return {
    focusedPage: _,
    totalPages: o,
    setFocusedPage: v,
    setTotalPages: r,
    nextPage: u,
    prevPage: P,
    goToPage: w
  };
}, _n = Ye({
  focusedPage: 0,
  setFocusedPage: (t) => {
  },
  goToPage: (t) => ({ success: !!t, currentPage: +t }),
  totalPages: 0,
  setTotalPages: (t) => {
  },
  prevPage: () => {
  },
  nextPage: () => {
  }
}), ie = () => {
  const t = Je(_n);
  return typeof (t == null ? void 0 : t.focusedPage) > "u" && Zr.error("Please use this hooks inside children component of RPProvider"), t;
}, Ms = ({ children: t }) => {
  const { pdf: e } = Q(), { focusedPage: n, totalPages: o, setFocusedPage: r, setTotalPages: a, goToPage: l, nextPage: c, prevPage: d } = To();
  return W(() => {
    e != null && e.numPages && (a(e.numPages), r(1));
  }, [e, a, r]), /* @__PURE__ */ i(
    _n.Provider,
    {
      value: {
        focusedPage: n,
        totalPages: o,
        setFocusedPage: r,
        setTotalPages: a,
        nextPage: c,
        prevPage: d,
        goToPage: l
      },
      children: t
    }
  );
};
const So = () => {
  const { pdf: t, pages: e } = Q(), [n, o] = $({
    loadedPages: 0,
    totalPages: 0,
    percentage: 0
  }), [r, a] = $(!1), [l, c] = $(!1), [d, p] = $(null), f = H(!1);
  W(() => {
    f.current;
  }, [f]);
  const _ = N(() => {
    document.documentElement.classList.remove("rp-print-html-printing"), document.body.classList.remove("rp-print-body-printing");
    const m = document.querySelector(".rp-print-zone");
    m && m.remove();
  }, []), h = N(() => {
    f.current = !1, a(!1), c(!1), p(null), o({
      loadedPages: 0,
      totalPages: 0,
      percentage: 0
    });
  }, []), v = () => {
    f.current = !0;
  }, w = async ({
    scratchCanvas: m,
    pdfDocument: g,
    pageNumber: s,
    viewerPdfPage: C,
    printResolution: b,
    optionalContentConfigPromise: y,
    printAnnotationStoragePromise: E
  }) => {
    if (f.current) {
      h();
      return;
    }
    const I = b / yr.PDF;
    m.width = Math.floor(C.width * I), m.height = Math.floor(C.height * I);
    const L = m.getContext("2d");
    L.save(), L.fillStyle = "rgb(255, 255, 255)", L.fillRect(0, 0, m.width, m.height), L.restore();
    const [D, z] = await Promise.all([
      g.getPage(s),
      E
    ]);
    if (f.current) {
      h();
      return;
    }
    const A = {
      canvasContext: L,
      transform: [I, 0, 0, I, 0, 0],
      viewport: D.getViewport({ scale: 1, rotation: C.rotation }),
      intent: "print",
      annotationMode: Ir.ENABLE_STORAGE,
      optionalContentConfigPromise: y,
      printAnnotationStorage: z
    };
    try {
      return D.render(A).promise;
    } catch (R) {
      throw R instanceof xr || console.error(R), R;
    }
  }, T = N(() => {
    const m = window.print;
    return new Promise((g) => {
      const s = (y) => {
        setTimeout(() => {
          m.call(window), setTimeout(() => y(), 20);
        }, 0);
      };
      if (document.querySelector(".rp-print-zone")) {
        s(g);
        return;
      }
      const b = new MutationObserver(() => {
        document.querySelector(".rp-print-zone") && (s(g), b.disconnect());
      });
      b.observe(document.body, { childList: !0, subtree: !0 });
    });
  }, []), P = async (m) => {
    const g = document.createElement("img"), s = document.createElement("div");
    return s.classList.add("rp-print-page"), await new Promise((C, b) => {
      m.toBlob((y) => {
        y ? (g.src = URL.createObjectURL(y), g.onload = () => {
          URL.revokeObjectURL(g.src), C();
        }, g.onerror = b) : b(new Error("Failed to create blob"));
      });
    }).catch(() => {
    }), s.appendChild(g), s;
  }, S = (m, g) => {
    const s = document.createElement("div");
    s.classList.add("rp-print-zone");
    const C = document.createElement("style"), b = g.get(1);
    if (b) {
      const { width: y, height: E } = b == null ? void 0 : b.page.getViewport({ scale: 1 });
      C.innerHTML = `@page { size: ${y}px ${E}px }`;
    }
    return s.appendChild(C), s.append(...m), s;
  }, u = N(async () => {
    if (!t)
      return;
    h();
    const m = document.createElement("canvas"), g = [];
    try {
      t.isPureXfa && console.warn("[rp] XFA Form is not supported at the moment.");
      const C = t.getOptionalContentConfig({ intent: "print" }), b = Promise.resolve(
        t.annotationStorage.print ?? void 0
      ), y = e.size;
      for (const [I, L] of e) {
        if (f.current) {
          h();
          return;
        }
        const D = L.page.getViewport({ scale: 1 });
        if (await w({
          scratchCanvas: m,
          pdfDocument: t,
          pageNumber: I,
          viewerPdfPage: D,
          printResolution: 150,
          optionalContentConfigPromise: C,
          printAnnotationStoragePromise: b
        }), f.current) {
          h();
          return;
        }
        const z = await P(m);
        g.push(z);
        const A = parseFloat((g.length / y * 100).toFixed(2));
        o({
          loadedPages: I,
          totalPages: y,
          percentage: A
        });
      }
      if (f.current) {
        h();
        return;
      }
      const E = S(g, e);
      document.body.appendChild(E), document.documentElement.classList.add("rp-print-html-printing"), document.body.classList.add("rp-print-body-printing"), a(!0), await T();
    } catch (s) {
      c(!0), s instanceof Error && p(s);
    } finally {
      m.height = 0, m.width = 0;
    }
  }, [t, e, f]);
  return W(() => {
    const m = () => {
      h(), _();
    };
    return window.addEventListener("afterprint", m, !0), () => {
      window.removeEventListener("afterprint", m, !0);
    };
  }, [_, h]), {
    print: u,
    cancel: v,
    progress: n,
    isComplete: r,
    isError: l,
    error: d
  };
}, bn = Ye({
  print: () => {
  },
  cancel: () => {
  },
  setOnProgress: (t) => {
  },
  progress: {},
  setOnComplete: (t) => t(),
  setOnError: (t) => {
    try {
      const e = new Error("Print error occurred");
      t(e);
    } catch (e) {
      console.error("Error in setOnError callback:", e);
    }
  }
}), Hs = ({ children: t }) => {
  const [e, n] = $(null), [o, r] = $(null), { print: a, cancel: l, progress: c, isComplete: d, isError: p, error: f } = So(), _ = N((P) => {
    P && typeof P == "function" && r(() => P);
  }, []), h = (P) => {
    f && P(f);
  }, v = N(
    (P) => {
      n(() => P);
    },
    [c, e]
  );
  W(() => {
    d && o && w();
  }, [d, o]), W(() => {
    p && h((P) => {
      console.error(P);
    });
  }, [p]), W(() => {
    c && e && e(c);
  }, [c, e]);
  const w = () => {
    o && (o(), r(null));
  }, T = {
    print: a,
    cancel: l,
    setOnProgress: v,
    setOnComplete: _,
    setOnError: h,
    progress: c
  };
  return /* @__PURE__ */ i(bn.Provider, { value: T, children: t });
}, tt = () => {
  const t = Je(bn);
  if (!t)
    throw new Error("usePrintContext must be used within a PrintProvider");
  return t;
}, yo = () => {
  const [t, e] = $({}), { pages: n } = Q(), { rotate: o } = Ge(), r = k(() => Object.keys(t).length, [t]), a = N(
    (c) => {
      if (!n.size)
        return;
      const d = c > n.size ? n.size : c, p = Array.from(n.values()).slice(0, d).map((h) => {
        const { thumbnailViewport: v, scale: w } = Wt(h.page, o);
        return {
          scale: w,
          page: h.page,
          loading: !0,
          viewport: v
        };
      }), f = p.reduce((h, v) => (h[v.page.pageNumber] = v, h), {});
      e(f);
      const _ = [];
      for (const h of p) {
        const v = document.createElement("canvas"), w = vt(h.page, v, {
          scale: h.scale,
          rotate: o
        }).promise.then(() => {
          const T = v.toDataURL();
          return {
            ...h,
            thumbnailSrc: T,
            loading: !1
          };
        });
        _.push(w);
      }
      Promise.all(_).then((h) => {
        const v = h.reduce(
          (w, T) => (w[T.page.pageNumber] = T, w),
          {}
        );
        e((w) => ({ ...w, ...v }));
      }).catch(() => {
      });
    },
    [n, o]
  );
  W(() => {
    a(10);
  }, [a]);
  const l = N(
    (c) => {
      if (!n)
        return;
      const d = n.get(c);
      if (!d)
        return;
      e((f) => ({
        ...f,
        [c]: {
          loading: !0,
          page: d.page,
          viewport: d.thumbnailViewport,
          scale: d.thumbnailScale
        }
      }));
      const p = document.createElement("canvas");
      vt(d.page, p, { scale: d.thumbnailScale, rotate: o }).promise.then(() => {
        const f = p.toDataURL(), { thumbnailViewport: _, scale: h } = Wt(d.page, o);
        return {
          scale: h,
          thumbnailSrc: f,
          page: d.page,
          loading: !1,
          viewport: _
        };
      }).then((f) => {
        e((_) => ({ ..._, [c]: f }));
      });
    },
    [n, o]
  );
  return { thumbnailPages: t, addPage: l, addToPage: a, thumbnailLength: r };
}, Cn = Ye({
  thumbnailPages: {},
  addPage: (t) => {
  },
  addToPage: (t) => {
  },
  thumbnailLength: 0,
  setActive: (t) => {
  },
  active: !1
}), Pn = () => Je(Cn), $s = ({
  children: t,
  initialThumbnailsVisible: e
}) => {
  const { thumbnailPages: n, addPage: o, addToPage: r, thumbnailLength: a } = yo(), [l, c] = $(e);
  return /* @__PURE__ */ i(
    Cn.Provider,
    {
      value: { thumbnailPages: n, addPage: o, addToPage: r, thumbnailLength: a, active: l, setActive: c },
      children: t
    }
  );
}, Io = (t = {}, e = "") => {
  const [n, o] = $(e), [r, a] = $(!1), { pdf: l, pages: c } = Q(), { widths: d, heights: p } = Ue(), f = H(!n), { currentZoom: _ } = Qe(), [h, v] = $([]), { setFocusedPage: w } = ie(), { columnCount: T } = Ee(), { rotate: P } = Ge(), [S, u] = $(0), { pageScrollElementRef: m, virtualScrollableElementRef: g } = et(), { scrollMode: s } = Re(), { pagesRef: C } = ge(), [b, y] = $(null), E = H({}), I = k(() => S === 0 ? null : h[S - 1], [S, h]), L = k(() => h.length, [h]);
  W(() => {
    if (!I || !c)
      return;
    const R = g || m;
    if (!R || !C)
      return;
    const x = c.get(I.page);
    if (s === J.PAGE_SCROLLING && w(I.page), !x)
      return;
    let O = 0, M = 0;
    if (s === J.VERTICAL_SCROLLING) {
      const ae = I.page - 1, de = T, te = ae % de, Fe = Math.floor(ae / de);
      O = Ae(p, Fe), M = Ae(d, te);
    }
    s === J.HORIZONTAL_SCROLLING && (M = d.slice(0, I.page - 1).reduce((ae, de) => ae + de, 0));
    const G = {
      top: C.clientHeight / 2,
      left: C.clientWidth / 2
    }, Z = {
      height: p[I.page - 1],
      width: d[I.page - 1]
    }, { leftInPage: j, topInPage: q } = Br(
      Z,
      G,
      I.rect,
      _,
      P
    ), ee = M + j, X = O + q, le = {
      left: Math.max(ee, 0),
      top: Math.max(X, 0)
    };
    R.scrollTo({
      ...le
    });
  }, [
    c,
    w,
    d,
    p,
    I,
    s,
    g,
    m,
    C
  ]);
  const D = N(() => {
    u((R) => L ? R + 1 > L ? 1 : R + 1 : 0);
  }, [L]), z = N(() => {
    u((R) => L ? R - 1 <= 0 ? L : R - 1 : 0);
  }, [L]), A = N(async (R) => {
    if (!R)
      return {};
    const x = R.numPages, O = {};
    for (let M = 1; M <= x; M++) {
      if (f.current)
        throw "close pop over";
      const G = await R.getPage(M);
      O[M.toString()] = await G.getTextContent();
    }
    return O;
  }, []);
  return W(() => {
    if (!n) {
      f.current = !0, v([]), u(0);
      return;
    }
    f.current = !1, a(!0), v([]), u(0), A(l).then((R) => {
      E.current = R;
      const O = Object.keys(R).reduce((M, G) => {
        const Z = cr(
          [n],
          R[G],
          Number(G) - 1,
          t
        ).map((j, q) => ({ ...j, page: Number(G), pageMatchIdx: q }));
        return [...M, ...Z];
      }, []);
      v(O), u(O.length ? 1 : 0);
    }).catch(() => {
      v([]), u(0);
    }).finally(() => a(!1));
  }, [n, A, l, t]), {
    search: n,
    setSearch: o,
    loading: r,
    matches: h,
    totalMatches: L,
    currentMatchPosition: S,
    currentMatch: I,
    nextMatch: D,
    prevMatch: z,
    currentMatchElement: b,
    setCurrentMatchElement: y
  };
}, Tn = Ye({
  search: "",
  setSearch: (t) => {
  },
  loading: !1,
  matches: [],
  totalMatches: 0,
  currentMatchPosition: 0,
  currentMatch: null,
  nextMatch: () => {
  },
  prevMatch: () => {
  },
  searchOptions: {},
  setSearchOptions: (t) => t,
  currentMatchElement: null,
  setCurrentMatchElement: (t) => {
  }
}), Gs = ({
  children: t,
  initialSearch: e
}) => {
  const [n, o] = $({}), {
    loading: r,
    setSearch: a,
    totalMatches: l,
    currentMatchPosition: c,
    currentMatch: d,
    search: p,
    matches: f,
    nextMatch: _,
    prevMatch: h,
    currentMatchElement: v,
    setCurrentMatchElement: w
  } = Io(n, e);
  return /* @__PURE__ */ i(
    Tn.Provider,
    {
      value: {
        searchOptions: n,
        setSearchOptions: o,
        loading: r,
        setSearch: a,
        totalMatches: l,
        currentMatchPosition: c,
        currentMatch: d,
        nextMatch: _,
        prevMatch: h,
        search: p,
        matches: f,
        currentMatchElement: v,
        setCurrentMatchElement: w
      },
      children: t
    }
  );
}, It = () => Je(Tn), ue = {
  "rp-pages": "_rp-pages_1776r_1",
  "rp-pages-horizontal-scroll": "_rp-pages-horizontal-scroll_1776r_7",
  "rp-pages-container": "_rp-pages-container_1776r_11",
  "rp-page-scrolling-wrapper": "_rp-page-scrolling-wrapper_1776r_17",
  "rp-viewer": "_rp-viewer_1776r_22",
  "rp-cursor-grab": "_rp-cursor-grab_1776r_27",
  "rp-cursor-grabbing": "_rp-cursor-grabbing_1776r_35",
  "rp-loader": "_rp-loader_1776r_43"
}, lt = {
  "rp-page-wrapper": "_rp-page-wrapper_14ohm_1",
  "rp-page": "_rp-page_14ohm_1",
  "rp-loader-wrapper": "_rp-loader-wrapper_14ohm_15"
}, xo = (t) => {
  const { pageNumber: e, onLoaded: n, onLoading: o } = t, r = H(null), { pages: a } = Q(), { rotate: l } = Ge(), c = H(), { currentZoom: d } = Qe();
  return W(() => {
    if (!a || d === 0)
      return;
    const p = a.get(e);
    if (r.current && p) {
      const f = r.current;
      f.hidden = !0;
      const _ = c.current;
      _ && _.cancel(), o && o(), c.current = vt(p.page, f, {
        scale: d,
        rotate: l,
        renderForms: !0
      }), c.current.promise.then(() => {
        f.hidden = !1;
      }).catch(() => {
      }).finally(() => {
        n && n();
      });
    }
    return () => {
      var f;
      (f = c.current) == null || f.cancel();
    };
  }, [a, e, l, d, o, n]), /* @__PURE__ */ i("canvas", { "data-rp": `page-${e}-canvas`, ref: r });
}, Lo = "_selecting_1x8te_9", Ro = "_endOfContent_1x8te_24", he = {
  "rp-text-layer": "_rp-text-layer_1x8te_1",
  selecting: Lo,
  endOfContent: Ro,
  "rp-text-layer-text": "_rp-text-layer-text_1x8te_38"
}, Eo = (t) => {
  const { pageNumber: e } = t, { pages: n } = Q(), o = H(null), { matches: r, currentMatch: a, setCurrentMatchElement: l } = It(), [c, d] = $(
    []
  ), p = H(), f = H(), _ = H([]), h = k(() => r.filter((m) => m.pageIndex === e - 1), [r, e]), v = N(
    (m, g, s = !1) => {
      if (s && lr(m, g), !h.length) {
        _.current = [], d([]);
        return;
      }
      const C = dr(h, m, g);
      d(C);
    },
    [h]
  ), w = H(), T = H(!1), P = N(() => Array.from(document.querySelectorAll('[data-rp$="-textLayer"]')), []);
  W(() => ((() => {
    if (w.current)
      return;
    w.current = new AbortController();
    const { signal: g } = w.current, s = () => {
      P().forEach((b) => {
        const y = b.querySelector(".endOfContent");
        y && (b.appendChild(y), y.style.width = "", y.style.height = "", b.classList.remove(he.selecting));
      });
    };
    document.addEventListener(
      "pointerdown",
      () => {
        T.current = !0;
      },
      { signal: g }
    ), document.addEventListener(
      "pointerup",
      () => {
        T.current = !1, s();
      },
      { signal: g }
    ), window.addEventListener(
      "blur",
      () => {
        T.current = !1, s();
      },
      { signal: g }
    ), document.addEventListener(
      "keyup",
      () => {
        T.current || s();
      },
      { signal: g }
    );
    let C = null;
    document.addEventListener(
      "selectionchange",
      () => {
        var A, R;
        const b = document.getSelection();
        if (!b)
          return;
        if (b.rangeCount === 0) {
          s();
          return;
        }
        const y = /* @__PURE__ */ new Set();
        for (let x = 0; x < b.rangeCount; x++) {
          const O = b.getRangeAt(x);
          P().forEach((M) => {
            O.intersectsNode(M) && !y.has(M) && y.add(M);
          });
        }
        P().forEach((x) => {
          if (y.has(x))
            x.classList.add(he.selecting);
          else {
            const O = x.querySelector(".endOfContent");
            O && (x.appendChild(O), O.style.width = "", O.style.height = "", x.classList.remove(he.selecting));
          }
        });
        const E = b.getRangeAt(0);
        let L = C && (E.compareBoundaryPoints(Range.END_TO_END, C) === 0 || E.compareBoundaryPoints(Range.START_TO_END, C) === 0) ? E.startContainer : E.endContainer;
        L.nodeType === Node.TEXT_NODE && (L = L.parentNode);
        const D = (A = L.parentElement) == null ? void 0 : A.closest(
          he["rp-text-layer"]
        ), z = D == null ? void 0 : D.querySelector(".endOfContent");
        z && D && (z.style.width = D.style.width, z.style.height = D.style.height, (R = L.parentElement) == null || R.insertBefore(z, L.nextSibling)), C = E.cloneRange();
      },
      { signal: g }
    );
  })(), () => {
    var g;
    (g = w.current) == null || g.abort(), w.current = void 0;
  }), [P]);
  const S = N(() => {
    o.current && o.current.classList.add(he.selecting);
  }, []), u = N(() => {
    o.current && o.current.classList.remove(he.selecting);
  }, []);
  return W(() => {
    if (_.current.forEach((s) => {
      s.classList.remove("selected");
    }), !c.length || !a || a.pageIndex !== e - 1)
      return;
    const m = h.findIndex(
      (s) => JSON.stringify(s) === JSON.stringify(a)
    );
    if (m === -1)
      return;
    const g = c.filter((s) => s.index === m);
    g.length && (_.current = g.map((s) => s.element), l(g[0].element), g.forEach((s) => {
      s.element.classList.add("selected");
    }));
  }, [a, c, h]), W(() => {
    const m = n.get(e);
    if (!m || !o.current)
      return;
    const g = o.current;
    return p.current && p.current.cancel(), m.page.getTextContent().then((s) => {
      const C = m.page.getViewport({ scale: 1 });
      return p.current = new Sr.TextLayer({
        viewport: C,
        textContentSource: s,
        container: g
      }), f.current = s, g && (g.innerText = ""), p.current.render();
    }).then(() => {
      var y, E;
      [].slice.call(g.children).forEach((I) => {
        I.classList.add(he["rp-text-layer-text"]), I.setAttribute("data-rp", "rp-text-layer-text");
      });
      const C = (y = p.current) == null ? void 0 : y.textDivs;
      C && f.current && v(f.current, C);
      const b = document.createElement("div");
      b.className = "endOfContent", (E = o.current) == null || E.appendChild(b);
    }).catch(() => {
    }), () => {
      var s;
      (s = p.current) == null || s.cancel();
    };
  }, [n, e]), W(() => {
    var s;
    [].slice.call(o.current.children).forEach((C) => {
      C.classList.add(he["rp-text-layer-text"]);
    });
    const g = (s = p.current) == null ? void 0 : s.textDivs;
    g && f.current && v(f.current, g, !0);
  }, [v]), /* @__PURE__ */ i(
    "div",
    {
      "data-rp": `page-${e}-textLayer`,
      className: he["rp-text-layer"],
      ref: o,
      onMouseDown: S,
      onMouseUp: u
    }
  );
}, No = {
  "rp-annotation-layer": "_rp-annotation-layer_o0ksd_1"
};
let Oo = "https://unpkg.com/pdfjs-dist@4.4.168/web/images/";
const Do = (t) => {
  const { pageNumber: e } = t, n = H(null), { pages: o, pdf: r } = Q(), a = H(), [l, c] = $(), { setFocusedPage: d, goToPage: p } = ie(), { scrollMode: f } = Re(), { print: _ } = tt(), { download: h } = $n(), v = k(() => o.get(e), [o, e]), w = k(() => v == null ? void 0 : v.page.getViewport(), [v]);
  W(() => {
    a.current && (a.current.div.replaceChildren(), a.current = void 0);
  }, [r]), W(() => {
    v && v.page.getAnnotations().then((P) => {
      a.current = void 0, c(P), n.current && (n.current.innerText = "");
    });
  }, [v]);
  const T = N(
    (P) => {
      !l || !r || (Er(P), Nr(P, r, l).then((S) => {
        var u, m;
        ((u = S == null ? void 0 : S.data) == null ? void 0 : u.action) === "Print" ? _() : ((m = S == null ? void 0 : S.data) == null ? void 0 : m.action) === "SaveAs" && h();
      }), f === J.PAGE_SCROLLING ? At(P, l, r, (S) => d(S.pageIndex + 1)) : At(P, l, r, (S) => p(S.pageIndex + 1)));
    },
    [r, l, p, d, f, _, h]
  );
  return W(() => {
    if (!v || !l)
      return;
    const P = v.page.getViewport();
    if (a.current) {
      a.current.update({
        viewport: P.clone({ dontFlip: !0 })
      });
      return;
    }
    const S = /* @__PURE__ */ new Map([]);
    for (const g of l) {
      const { annotationType: s } = g;
      switch (s) {
        case zt.Link:
          Dr(g);
          break;
        case zt.Widget:
          Or(g, P, S);
          break;
      }
    }
    const u = new AbortController();
    return (async () => {
      var C;
      a.current && (a.current.div.replaceChildren(), a.current = void 0), n.current && (n.current.innerText = ""), a.current = new Lr({
        div: n.current,
        accessibilityManager: void 0,
        annotationCanvasMap: void 0,
        annotationEditorUIManager: void 0,
        structTreeLayer: null,
        page: v.page,
        viewport: P.clone({ dontFlip: !0 })
      }), n.current && Ft(n.current, T);
      const g = await (r == null ? void 0 : r.hasJSActions()), s = await (r == null ? void 0 : r.getFieldObjects());
      if (u.signal.aborted)
        throw "abort";
      return (C = a.current) == null ? void 0 : C.render({
        annotations: l,
        annotationStorage: r == null ? void 0 : r.annotationStorage,
        hasJSActions: g,
        fieldObjects: s,
        div: n.current,
        viewport: P.clone({ dontFlip: !0 }),
        page: v.page,
        imageResourcesPath: Oo,
        renderForms: !0,
        linkService: new Rr(),
        downloadManager: null,
        enableScripting: !1
      });
    })().then(() => {
      n.current && zr(n.current, T);
    }).catch((g) => {
      if (g !== "abort")
        throw g;
    }), () => {
      u.abort("clear"), n.current && Ft(n.current, T);
    };
  }, [r, l, T]), /* @__PURE__ */ i(
    "div",
    {
      "data-rp": `page-${e}-annotationLayer`,
      style: { width: `${w == null ? void 0 : w.width}px`, height: `${w == null ? void 0 : w.height}px` },
      className: No["rp-annotation-layer"],
      ref: n
    }
  );
}, zo = {
  "rp-text-highlight": "_rp-text-highlight_jdkf8_1"
}, Ao = ({ pageNumber: t, viewport: e }) => {
  const [n, o] = $(), { pages: r } = Q(), { highlightKeywords: a } = pr(), l = !0, c = H(null), [d, p] = $(null), [f, _] = $([]);
  W(() => {
    c.current && p(c.current.parentElement);
  }, [c]), W(() => {
    (async () => {
      const m = r.get(t);
      if (!m || !c.current)
        return;
      const g = await m.page.getTextContent();
      o(g);
    })();
  }, [r, t]);
  const h = k(() => a ? a.map((u) => {
    var m, g;
    return {
      ...Ar(u.keyword, (m = u.options) == null ? void 0 : m.matchCase, (g = u.options) == null ? void 0 : g.wholeWords),
      color: u.highlightColor
    };
  }) : [], [a]);
  function v(u, m) {
    if (!u)
      return;
    const g = `[data-rp="page-${m}-textLayer"]`;
    return new Promise((s) => {
      const C = u.querySelector(g);
      if (C) {
        s(C);
        return;
      }
      new MutationObserver((y, E) => {
        const I = u.querySelector(g);
        I && (s(I), E.disconnect());
      }).observe(u, { childList: !0, subtree: !0 });
    });
  }
  function w(u) {
    return new Promise((m) => {
      const g = u.querySelectorAll(
        '[data-rp="rp-text-layer-text"]'
      );
      if (g.length) {
        m(Array.from(g));
        return;
      }
      new MutationObserver((C, b) => {
        const y = u.querySelectorAll(
          ".vpv-text-layer-text"
        );
        y.length && (m(Array.from(y)), b.disconnect());
      }).observe(u, { childList: !0, subtree: !0 });
    });
  }
  const T = (u, m, g, s) => {
    var Z;
    const C = document.createRange(), b = g.firstChild;
    if (!b || b.nodeType !== Node.TEXT_NODE)
      return null;
    const y = ((Z = b.textContent) == null ? void 0 : Z.length) ?? 0, E = s[0].charIdxInSpan, I = s.length === 1 ? E : s[s.length - 1].charIdxInSpan;
    if (E > y || I + 1 > y)
      return null;
    C.setStart(b, E), C.setEnd(b, I + 1);
    const L = document.createElement("span");
    L.style.width = "auto", C.surroundContents(L);
    const D = L.getBoundingClientRect(), z = u.getBoundingClientRect(), A = z.height, R = z.width, x = 100 * (D.left - z.left) / R, O = 100 * (D.top - z.top) / A, M = 100 * D.height / A, G = 100 * D.width / R;
    return Wr(L), {
      keywordStr: m,
      left: x,
      top: O,
      height: M,
      width: G,
      pageHeight: A,
      pageWidth: R
    };
  };
  async function P(u, m) {
    const g = await v(d, u);
    if (!g)
      return;
    const s = await w(g);
    if (s.length) {
      const C = s.map((y) => y.tagName === "BR" ? " " : y.textContent).reduce(
        (y, E, I) => y.concat(
          E.split("").map((L, D) => ({
            char: L,
            charIdxInSpan: D,
            spanIdx: I
          }))
        ),
        [
          {
            char: "",
            charIdxInSpan: 0,
            spanIdx: 0
          }
        ]
      ).slice(1), b = S(g, m, s, C);
      _(b);
    }
  }
  const S = (u, m, g, s) => {
    const C = m.length;
    if (!s.length || !C)
      return [];
    const b = [], y = s.map((E) => E.char).join("");
    return h.forEach((E) => {
      const { keyword: I, regExp: L, wholeWords: D, color: z } = E, A = I;
      if (!A.trim())
        return;
      const R = L.flags.indexOf("g") === -1 ? new RegExp(L, `${L.flags}g`) : L;
      let x;
      const O = [];
      for (; (x = R.exec(y)) !== null; )
        D && !ur(y, x.index, x[0].length) || O.push({
          keyword: R,
          startIndex: x.index,
          endIndex: R.lastIndex
        });
      const M = O.map((G) => ({
        keyword: G.keyword,
        indexes: s.slice(G.startIndex, G.endIndex),
        color: z
      }));
      for (const G of M) {
        const Z = G.indexes.reduce(
          (j, q) => (j[q.spanIdx] = (j[q.spanIdx] || []).concat([q]), j),
          {}
        );
        for (const j of Object.values(Z))
          if (j.length !== 1 || j[0].char.trim() !== "") {
            const q = j, ee = g[q[0].spanIdx], X = T(
              u,
              A,
              ee,
              q
            );
            if (X) {
              const { left: le, top: ae } = X;
              if (b.find((te) => te.left === le && te.top === ae))
                continue;
              b.push({ ...X, highlightColor: G.color });
            }
          }
      }
    }), b.sort(Fr), b;
  };
  return W(() => {
    (async () => {
      if (!(!a || a.length === 0))
        try {
          await P(t, a);
        } catch (m) {
          console.error(m);
        }
    })();
  }, [l, a, t, n, e]), /* @__PURE__ */ i(fe, { children: /* @__PURE__ */ i("div", { ref: c, "data-rp": `page-${t}-textHighlightLayer`, children: f.map((u, m) => /* @__PURE__ */ i(
    "div",
    {
      className: zo["rp-text-highlight"],
      style: {
        top: `${u.top}%`,
        left: `${u.left}%`,
        width: `${u.width}%`,
        height: `${u.height}%`,
        backgroundColor: u.highlightColor
      }
    },
    m
  )) }) });
}, xt = $e((t, e) => {
  const { pageNumber: n, style: o, ...r } = t, { pages: a } = Q(), { rotate: l } = Ge(), { textLayer: c } = or(), { currentZoom: d } = Qe(), p = H(a.get(n)), [f, _] = $(!1), h = H(null), [v, w] = $({
    width: 0,
    height: 0
  });
  cn(e, () => h.current), W(() => {
    if (a && (p.current = a.get(n), p.current)) {
      const u = p.current.page.getViewport({ scale: d, rotation: l });
      w(u);
    }
  }, [a, n, l, d]);
  const T = k(() => {
    switch (l) {
      case 90:
        return `${v.width / 2}px ${v.width / 2}px`;
      case -90:
      case 270:
        return `${v.height / 2}px ${v.height / 2}px`;
      default:
        return "center";
    }
  }, [l, v]), P = N(() => {
    _(!0);
  }, []), S = N(() => {
    _(!1);
  }, []);
  return /* @__PURE__ */ i(
    "div",
    {
      ref: h,
      id: `page-${n}`,
      "data-rp": `page-${n}`,
      ...r,
      style: {
        ...o,
        "--rp-rotate": `${l}deg`,
        "--rp-page-rotate-translate": `${T}`,
        "--scale-factor": d
      },
      className: lt["rp-page-wrapper"],
      children: /* @__PURE__ */ F(
        "div",
        {
          style: {
            width: `${v.width}px`,
            height: `${v.height}px`
          },
          className: lt["rp-page"],
          children: [
            /* @__PURE__ */ i(xo, { onLoading: P, onLoaded: S, pageNumber: n }),
            f && /* @__PURE__ */ i("div", { className: lt["rp-loader-wrapper"], children: /* @__PURE__ */ i(Ct, {}) }),
            c && /* @__PURE__ */ i(Eo, { pageNumber: n }),
            /* @__PURE__ */ i(Ao, { pageNumber: n, viewport: v }),
            /* @__PURE__ */ i(Do, { pageNumber: n })
          ]
        }
      )
    }
  );
});
function Ut(t) {
  if (t === void 0)
    throw new ReferenceError("this hasn't been initialised - super() hasn't been called");
  return t;
}
function wt(t, e) {
  return wt = Object.setPrototypeOf ? Object.setPrototypeOf.bind() : function(n, o) {
    return n.__proto__ = o, n;
  }, wt(t, e);
}
function Fo(t, e) {
  t.prototype = Object.create(e.prototype), t.prototype.constructor = t, wt(t, e);
}
var Vt = Number.isNaN || function(e) {
  return typeof e == "number" && e !== e;
};
function Wo(t, e) {
  return !!(t === e || Vt(t) && Vt(e));
}
function ko(t, e) {
  if (t.length !== e.length)
    return !1;
  for (var n = 0; n < t.length; n++)
    if (!Wo(t[n], e[n]))
      return !1;
  return !0;
}
function dt(t, e) {
  e === void 0 && (e = ko);
  var n, o = [], r, a = !1;
  function l() {
    for (var c = [], d = 0; d < arguments.length; d++)
      c[d] = arguments[d];
    return a && n === this && e(c, o) || (r = t.apply(this, c), a = !0, n = this, o = c), r;
  }
  return l;
}
function qt(t, e) {
  if (t == null)
    return {};
  var n = {};
  for (var o in t)
    if ({}.hasOwnProperty.call(t, o)) {
      if (e.indexOf(o) !== -1)
        continue;
      n[o] = t[o];
    }
  return n;
}
var Mo = typeof performance == "object" && typeof performance.now == "function", Bt = Mo ? function() {
  return performance.now();
} : function() {
  return Date.now();
};
function Zt(t) {
  cancelAnimationFrame(t.id);
}
function Ho(t, e) {
  var n = Bt();
  function o() {
    Bt() - n >= e ? t.call(null) : r.id = requestAnimationFrame(o);
  }
  var r = {
    id: requestAnimationFrame(o)
  };
  return r;
}
var ut = -1;
function $o(t) {
  if (t === void 0 && (t = !1), ut === -1 || t) {
    var e = document.createElement("div"), n = e.style;
    n.width = "50px", n.height = "50px", n.overflow = "scroll", document.body.appendChild(e), ut = e.offsetWidth - e.clientWidth, document.body.removeChild(e);
  }
  return ut;
}
var Oe = null;
function jt(t) {
  if (t === void 0 && (t = !1), Oe === null || t) {
    var e = document.createElement("div"), n = e.style;
    n.width = "50px", n.height = "50px", n.overflow = "scroll", n.direction = "rtl";
    var o = document.createElement("div"), r = o.style;
    return r.width = "100px", r.height = "100px", e.appendChild(o), document.body.appendChild(e), e.scrollLeft > 0 ? Oe = "positive-descending" : (e.scrollLeft = 1, e.scrollLeft === 0 ? Oe = "negative" : Oe = "positive-ascending"), document.body.removeChild(e), Oe;
  }
  return Oe;
}
var Go = 150, Uo = function(e) {
  var n = e.columnIndex;
  e.data;
  var o = e.rowIndex;
  return o + ":" + n;
}, Be = null, Ze = null, je = null;
process.env.NODE_ENV !== "production" && typeof window < "u" && typeof window.WeakSet < "u" && (Be = /* @__PURE__ */ new WeakSet(), Ze = /* @__PURE__ */ new WeakSet(), je = /* @__PURE__ */ new WeakSet());
function Vo(t) {
  var e, n = t.getColumnOffset, o = t.getColumnStartIndexForOffset, r = t.getColumnStopIndexForStartIndex, a = t.getColumnWidth, l = t.getEstimatedTotalHeight, c = t.getEstimatedTotalWidth, d = t.getOffsetForColumnAndAlignment, p = t.getOffsetForRowAndAlignment, f = t.getRowHeight, _ = t.getRowOffset, h = t.getRowStartIndexForOffset, v = t.getRowStopIndexForStartIndex, w = t.initInstanceProps, T = t.shouldResetStyleCacheOnItemSizeChange, P = t.validateProps;
  return e = /* @__PURE__ */ function(S) {
    Fo(u, S);
    function u(g) {
      var s;
      return s = S.call(this, g) || this, s._instanceProps = w(s.props, Ut(s)), s._resetIsScrollingTimeoutId = null, s._outerRef = void 0, s.state = {
        instance: Ut(s),
        isScrolling: !1,
        horizontalScrollDirection: "forward",
        scrollLeft: typeof s.props.initialScrollLeft == "number" ? s.props.initialScrollLeft : 0,
        scrollTop: typeof s.props.initialScrollTop == "number" ? s.props.initialScrollTop : 0,
        scrollUpdateWasRequested: !1,
        verticalScrollDirection: "forward"
      }, s._callOnItemsRendered = void 0, s._callOnItemsRendered = dt(function(C, b, y, E, I, L, D, z) {
        return s.props.onItemsRendered({
          overscanColumnStartIndex: C,
          overscanColumnStopIndex: b,
          overscanRowStartIndex: y,
          overscanRowStopIndex: E,
          visibleColumnStartIndex: I,
          visibleColumnStopIndex: L,
          visibleRowStartIndex: D,
          visibleRowStopIndex: z
        });
      }), s._callOnScroll = void 0, s._callOnScroll = dt(function(C, b, y, E, I) {
        return s.props.onScroll({
          horizontalScrollDirection: y,
          scrollLeft: C,
          scrollTop: b,
          verticalScrollDirection: E,
          scrollUpdateWasRequested: I
        });
      }), s._getItemStyle = void 0, s._getItemStyle = function(C, b) {
        var y = s.props, E = y.columnWidth, I = y.direction, L = y.rowHeight, D = s._getItemStyleCache(T && E, T && I, T && L), z = C + ":" + b, A;
        if (D.hasOwnProperty(z))
          A = D[z];
        else {
          var R = n(s.props, b, s._instanceProps), x = I === "rtl";
          D[z] = A = {
            position: "absolute",
            left: x ? void 0 : R,
            right: x ? R : void 0,
            top: _(s.props, C, s._instanceProps),
            height: f(s.props, C, s._instanceProps),
            width: a(s.props, b, s._instanceProps)
          };
        }
        return A;
      }, s._getItemStyleCache = void 0, s._getItemStyleCache = dt(function(C, b, y) {
        return {};
      }), s._onScroll = function(C) {
        var b = C.currentTarget, y = b.clientHeight, E = b.clientWidth, I = b.scrollLeft, L = b.scrollTop, D = b.scrollHeight, z = b.scrollWidth;
        s.setState(function(A) {
          if (A.scrollLeft === I && A.scrollTop === L)
            return null;
          var R = s.props.direction, x = I;
          if (R === "rtl")
            switch (jt()) {
              case "negative":
                x = -I;
                break;
              case "positive-descending":
                x = z - E - I;
                break;
            }
          x = Math.max(0, Math.min(x, z - E));
          var O = Math.max(0, Math.min(L, D - y));
          return {
            isScrolling: !0,
            horizontalScrollDirection: A.scrollLeft < I ? "forward" : "backward",
            scrollLeft: x,
            scrollTop: O,
            verticalScrollDirection: A.scrollTop < L ? "forward" : "backward",
            scrollUpdateWasRequested: !1
          };
        }, s._resetIsScrollingDebounced);
      }, s._outerRefSetter = function(C) {
        var b = s.props.outerRef;
        s._outerRef = C, typeof b == "function" ? b(C) : b != null && typeof b == "object" && b.hasOwnProperty("current") && (b.current = C);
      }, s._resetIsScrollingDebounced = function() {
        s._resetIsScrollingTimeoutId !== null && Zt(s._resetIsScrollingTimeoutId), s._resetIsScrollingTimeoutId = Ho(s._resetIsScrolling, Go);
      }, s._resetIsScrolling = function() {
        s._resetIsScrollingTimeoutId = null, s.setState({
          isScrolling: !1
        }, function() {
          s._getItemStyleCache(-1);
        });
      }, s;
    }
    u.getDerivedStateFromProps = function(s, C) {
      return qo(s, C), P(s), null;
    };
    var m = u.prototype;
    return m.scrollTo = function(s) {
      var C = s.scrollLeft, b = s.scrollTop;
      C !== void 0 && (C = Math.max(0, C)), b !== void 0 && (b = Math.max(0, b)), this.setState(function(y) {
        return C === void 0 && (C = y.scrollLeft), b === void 0 && (b = y.scrollTop), y.scrollLeft === C && y.scrollTop === b ? null : {
          horizontalScrollDirection: y.scrollLeft < C ? "forward" : "backward",
          scrollLeft: C,
          scrollTop: b,
          scrollUpdateWasRequested: !0,
          verticalScrollDirection: y.scrollTop < b ? "forward" : "backward"
        };
      }, this._resetIsScrollingDebounced);
    }, m.scrollToItem = function(s) {
      var C = s.align, b = C === void 0 ? "auto" : C, y = s.columnIndex, E = s.rowIndex, I = this.props, L = I.columnCount, D = I.height, z = I.rowCount, A = I.width, R = this.state, x = R.scrollLeft, O = R.scrollTop, M = $o();
      y !== void 0 && (y = Math.max(0, Math.min(y, L - 1))), E !== void 0 && (E = Math.max(0, Math.min(E, z - 1)));
      var G = l(this.props, this._instanceProps), Z = c(this.props, this._instanceProps), j = Z > A ? M : 0, q = G > D ? M : 0;
      this.scrollTo({
        scrollLeft: y !== void 0 ? d(this.props, y, b, x, this._instanceProps, q) : x,
        scrollTop: E !== void 0 ? p(this.props, E, b, O, this._instanceProps, j) : O
      });
    }, m.componentDidMount = function() {
      var s = this.props, C = s.initialScrollLeft, b = s.initialScrollTop;
      if (this._outerRef != null) {
        var y = this._outerRef;
        typeof C == "number" && (y.scrollLeft = C), typeof b == "number" && (y.scrollTop = b);
      }
      this._callPropsCallbacks();
    }, m.componentDidUpdate = function() {
      var s = this.props.direction, C = this.state, b = C.scrollLeft, y = C.scrollTop, E = C.scrollUpdateWasRequested;
      if (E && this._outerRef != null) {
        var I = this._outerRef;
        if (s === "rtl")
          switch (jt()) {
            case "negative":
              I.scrollLeft = -b;
              break;
            case "positive-ascending":
              I.scrollLeft = b;
              break;
            default:
              var L = I.clientWidth, D = I.scrollWidth;
              I.scrollLeft = D - L - b;
              break;
          }
        else
          I.scrollLeft = Math.max(0, b);
        I.scrollTop = Math.max(0, y);
      }
      this._callPropsCallbacks();
    }, m.componentWillUnmount = function() {
      this._resetIsScrollingTimeoutId !== null && Zt(this._resetIsScrollingTimeoutId);
    }, m.render = function() {
      var s = this.props, C = s.children, b = s.className, y = s.columnCount, E = s.direction, I = s.height, L = s.innerRef, D = s.innerElementType, z = s.innerTagName, A = s.itemData, R = s.itemKey, x = R === void 0 ? Uo : R, O = s.outerElementType, M = s.outerTagName, G = s.rowCount, Z = s.style, j = s.useIsScrolling, q = s.width, ee = this.state.isScrolling, X = this._getHorizontalRangeToRender(), le = X[0], ae = X[1], de = this._getVerticalRangeToRender(), te = de[0], Fe = de[1], Ne = [];
      if (y > 0 && G)
        for (var Pe = te; Pe <= Fe; Pe++)
          for (var we = le; we <= ae; we++)
            Ne.push(qe(C, {
              columnIndex: we,
              data: A,
              isScrolling: j ? ee : void 0,
              key: x({
                columnIndex: we,
                data: A,
                rowIndex: Pe
              }),
              rowIndex: Pe,
              style: this._getItemStyle(Pe, we)
            }));
      var nt = l(this.props, this._instanceProps), rt = c(this.props, this._instanceProps);
      return qe(O || M || "div", {
        className: b,
        onScroll: this._onScroll,
        ref: this._outerRefSetter,
        style: kr({
          position: "relative",
          height: I,
          width: q,
          overflow: "auto",
          WebkitOverflowScrolling: "touch",
          willChange: "transform",
          direction: E
        }, Z)
      }, qe(D || z || "div", {
        children: Ne,
        ref: L,
        style: {
          height: nt,
          pointerEvents: ee ? "none" : void 0,
          width: rt
        }
      }));
    }, m._callPropsCallbacks = function() {
      var s = this.props, C = s.columnCount, b = s.onItemsRendered, y = s.onScroll, E = s.rowCount;
      if (typeof b == "function" && C > 0 && E > 0) {
        var I = this._getHorizontalRangeToRender(), L = I[0], D = I[1], z = I[2], A = I[3], R = this._getVerticalRangeToRender(), x = R[0], O = R[1], M = R[2], G = R[3];
        this._callOnItemsRendered(L, D, x, O, z, A, M, G);
      }
      if (typeof y == "function") {
        var Z = this.state, j = Z.horizontalScrollDirection, q = Z.scrollLeft, ee = Z.scrollTop, X = Z.scrollUpdateWasRequested, le = Z.verticalScrollDirection;
        this._callOnScroll(q, ee, j, le, X);
      }
    }, m._getHorizontalRangeToRender = function() {
      var s = this.props, C = s.columnCount, b = s.overscanColumnCount, y = s.overscanColumnsCount, E = s.overscanCount, I = s.rowCount, L = this.state, D = L.horizontalScrollDirection, z = L.isScrolling, A = L.scrollLeft, R = b || y || E || 1;
      if (C === 0 || I === 0)
        return [0, 0, 0, 0];
      var x = o(this.props, A, this._instanceProps), O = r(this.props, x, A, this._instanceProps), M = !z || D === "backward" ? Math.max(1, R) : 1, G = !z || D === "forward" ? Math.max(1, R) : 1;
      return [Math.max(0, x - M), Math.max(0, Math.min(C - 1, O + G)), x, O];
    }, m._getVerticalRangeToRender = function() {
      var s = this.props, C = s.columnCount, b = s.overscanCount, y = s.overscanRowCount, E = s.overscanRowsCount, I = s.rowCount, L = this.state, D = L.isScrolling, z = L.verticalScrollDirection, A = L.scrollTop, R = y || E || b || 1;
      if (C === 0 || I === 0)
        return [0, 0, 0, 0];
      var x = h(this.props, A, this._instanceProps), O = v(this.props, x, A, this._instanceProps), M = !D || z === "backward" ? Math.max(1, R) : 1, G = !D || z === "forward" ? Math.max(1, R) : 1;
      return [Math.max(0, x - M), Math.max(0, Math.min(I - 1, O + G)), x, O];
    }, u;
  }(Qn), e.defaultProps = {
    direction: "ltr",
    itemData: void 0,
    useIsScrolling: !1
  }, e;
}
var qo = function(e, n) {
  var o = e.children, r = e.direction, a = e.height, l = e.innerTagName, c = e.outerTagName, d = e.overscanColumnsCount, p = e.overscanCount, f = e.overscanRowsCount, _ = e.width, h = n.instance;
  if (process.env.NODE_ENV !== "production") {
    if (typeof p == "number" && Be && !Be.has(h) && (Be.add(h), console.warn("The overscanCount prop has been deprecated. Please use the overscanColumnCount and overscanRowCount props instead.")), (typeof d == "number" || typeof f == "number") && Ze && !Ze.has(h) && (Ze.add(h), console.warn("The overscanColumnsCount and overscanRowsCount props have been deprecated. Please use the overscanColumnCount and overscanRowCount props instead.")), (l != null || c != null) && je && !je.has(h) && (je.add(h), console.warn("The innerTagName and outerTagName props have been deprecated. Please use the innerElementType and outerElementType props instead.")), o == null)
      throw Error('An invalid "children" prop has been specified. Value should be a React component. ' + ('"' + (o === null ? "null" : typeof o) + '" was specified.'));
    switch (r) {
      case "ltr":
      case "rtl":
        break;
      default:
        throw Error('An invalid "direction" prop has been specified. Value should be either "ltr" or "rtl". ' + ('"' + r + '" was specified.'));
    }
    if (typeof _ != "number")
      throw Error('An invalid "width" prop has been specified. Grids must specify a number for width. ' + ('"' + (_ === null ? "null" : typeof _) + '" was specified.'));
    if (typeof a != "number")
      throw Error('An invalid "height" prop has been specified. Grids must specify a number for height. ' + ('"' + (a === null ? "null" : typeof a) + '" was specified.'));
  }
}, Kt = 50, Sn = function(e, n) {
  var o = e.rowCount, r = n.rowMetadataMap, a = n.estimatedRowHeight, l = n.lastMeasuredRowIndex, c = 0;
  if (l >= o && (l = o - 1), l >= 0) {
    var d = r[l];
    c = d.offset + d.size;
  }
  var p = o - l - 1, f = p * a;
  return c + f;
}, yn = function(e, n) {
  var o = e.columnCount, r = n.columnMetadataMap, a = n.estimatedColumnWidth, l = n.lastMeasuredColumnIndex, c = 0;
  if (l >= o && (l = o - 1), l >= 0) {
    var d = r[l];
    c = d.offset + d.size;
  }
  var p = o - l - 1, f = p * a;
  return c + f;
}, me = function(e, n, o, r) {
  var a, l, c;
  if (e === "column" ? (a = r.columnMetadataMap, l = n.columnWidth, c = r.lastMeasuredColumnIndex) : (a = r.rowMetadataMap, l = n.rowHeight, c = r.lastMeasuredRowIndex), o > c) {
    var d = 0;
    if (c >= 0) {
      var p = a[c];
      d = p.offset + p.size;
    }
    for (var f = c + 1; f <= o; f++) {
      var _ = l(f);
      a[f] = {
        offset: d,
        size: _
      }, d += _;
    }
    e === "column" ? r.lastMeasuredColumnIndex = o : r.lastMeasuredRowIndex = o;
  }
  return a[o];
}, Xt = function(e, n, o, r) {
  var a, l;
  e === "column" ? (a = o.columnMetadataMap, l = o.lastMeasuredColumnIndex) : (a = o.rowMetadataMap, l = o.lastMeasuredRowIndex);
  var c = l > 0 ? a[l].offset : 0;
  return c >= r ? In(e, n, o, l, 0, r) : Bo(e, n, o, Math.max(0, l), r);
}, In = function(e, n, o, r, a, l) {
  for (; a <= r; ) {
    var c = a + Math.floor((r - a) / 2), d = me(e, n, c, o).offset;
    if (d === l)
      return c;
    d < l ? a = c + 1 : d > l && (r = c - 1);
  }
  return a > 0 ? a - 1 : 0;
}, Bo = function(e, n, o, r, a) {
  for (var l = e === "column" ? n.columnCount : n.rowCount, c = 1; r < l && me(e, n, r, o).offset < a; )
    r += c, c *= 2;
  return In(e, n, o, Math.min(r, l - 1), Math.floor(r / 2), a);
}, Yt = function(e, n, o, r, a, l, c) {
  var d = e === "column" ? n.width : n.height, p = me(e, n, o, l), f = e === "column" ? yn(n, l) : Sn(n, l), _ = Math.max(0, Math.min(f - d, p.offset)), h = Math.max(0, p.offset - d + c + p.size);
  switch (r === "smart" && (a >= h - d && a <= _ + d ? r = "auto" : r = "center"), r) {
    case "start":
      return _;
    case "end":
      return h;
    case "center":
      return Math.round(h + (_ - h) / 2);
    case "auto":
    default:
      return a >= h && a <= _ ? a : h > _ || a < h ? h : _;
  }
}, Zo = /* @__PURE__ */ Vo({
  getColumnOffset: function(e, n, o) {
    return me("column", e, n, o).offset;
  },
  getColumnStartIndexForOffset: function(e, n, o) {
    return Xt("column", e, o, n);
  },
  getColumnStopIndexForStartIndex: function(e, n, o, r) {
    for (var a = e.columnCount, l = e.width, c = me("column", e, n, r), d = o + l, p = c.offset + c.size, f = n; f < a - 1 && p < d; )
      f++, p += me("column", e, f, r).size;
    return f;
  },
  getColumnWidth: function(e, n, o) {
    return o.columnMetadataMap[n].size;
  },
  getEstimatedTotalHeight: Sn,
  getEstimatedTotalWidth: yn,
  getOffsetForColumnAndAlignment: function(e, n, o, r, a, l) {
    return Yt("column", e, n, o, r, a, l);
  },
  getOffsetForRowAndAlignment: function(e, n, o, r, a, l) {
    return Yt("row", e, n, o, r, a, l);
  },
  getRowOffset: function(e, n, o) {
    return me("row", e, n, o).offset;
  },
  getRowHeight: function(e, n, o) {
    return o.rowMetadataMap[n].size;
  },
  getRowStartIndexForOffset: function(e, n, o) {
    return Xt("row", e, o, n);
  },
  getRowStopIndexForStartIndex: function(e, n, o, r) {
    for (var a = e.rowCount, l = e.height, c = me("row", e, n, r), d = o + l, p = c.offset + c.size, f = n; f < a - 1 && p < d; )
      f++, p += me("row", e, f, r).size;
    return f;
  },
  initInstanceProps: function(e, n) {
    var o = e, r = o.estimatedColumnWidth, a = o.estimatedRowHeight, l = {
      columnMetadataMap: {},
      estimatedColumnWidth: r || Kt,
      estimatedRowHeight: a || Kt,
      lastMeasuredColumnIndex: -1,
      lastMeasuredRowIndex: -1,
      rowMetadataMap: {}
    };
    return n.resetAfterColumnIndex = function(c, d) {
      d === void 0 && (d = !0), n.resetAfterIndices({
        columnIndex: c,
        shouldForceUpdate: d
      });
    }, n.resetAfterRowIndex = function(c, d) {
      d === void 0 && (d = !0), n.resetAfterIndices({
        rowIndex: c,
        shouldForceUpdate: d
      });
    }, n.resetAfterIndices = function(c) {
      var d = c.columnIndex, p = c.rowIndex, f = c.shouldForceUpdate, _ = f === void 0 ? !0 : f;
      typeof d == "number" && (l.lastMeasuredColumnIndex = Math.min(l.lastMeasuredColumnIndex, d - 1)), typeof p == "number" && (l.lastMeasuredRowIndex = Math.min(l.lastMeasuredRowIndex, p - 1)), n._getItemStyleCache(-1), _ && n.forceUpdate();
    }, l;
  },
  shouldResetStyleCacheOnItemSizeChange: !1,
  validateProps: function(e) {
    var n = e.columnWidth, o = e.rowHeight;
    if (process.env.NODE_ENV !== "production") {
      if (typeof n != "function")
        throw Error('An invalid "columnWidth" prop has been specified. Value should be a function. ' + ('"' + (n === null ? "null" : typeof n) + '" was specified.'));
      if (typeof o != "function")
        throw Error('An invalid "rowHeight" prop has been specified. Value should be a function. ' + ('"' + (o === null ? "null" : typeof o) + '" was specified.'));
    }
  }
});
process.env.NODE_ENV;
function Jt(t, e) {
  for (var n in t)
    if (!(n in e))
      return !0;
  for (var o in e)
    if (t[o] !== e[o])
      return !0;
  return !1;
}
var jo = ["style"], Ko = ["style"];
function Xo(t, e) {
  var n = t.style, o = qt(t, jo), r = e.style, a = qt(e, Ko);
  return !Jt(n, r) && !Jt(o, a);
}
const Yo = () => {
  const { viewMode: t } = Ee(), { scrollMode: e } = Re(), { setColumnCount: n } = un(), { virtualScrollableElementRef: o } = et(), r = Ue(), a = k(() => r.heights.length, [r.heights]), l = k(() => e === J.HORIZONTAL_SCROLLING ? a : t === xe.DUAL_PAGE ? 2 : 1, [t, e, e, a, o]), c = k(() => r.widths.reduce((w, T, P) => {
    const S = P % l;
    return (!w[S] || T > w[S]) && (w[S] = T), w;
  }, []), [r.widths, l]), d = N(
    (v) => {
      const w = v % c.length;
      return c[w] || 0;
    },
    [c]
  ), p = N(
    (v) => r.heights[v] || 0,
    [r.heights]
  );
  W(() => {
    n(l);
  }, [l, n]);
  const f = k(() => e === J.HORIZONTAL_SCROLLING || e === J.PAGE_SCROLLING ? 1 : Math.round(a / l), [l, a, e]), _ = k(() => r.heights.reduce((v, w) => v + w, 0) / r.heights.length || 0, [r]), h = k(() => r.widths.reduce((v, w) => v + w, 0) / r.heights.length || 0, [r]);
  return {
    rowCount: f,
    rowHeight: p,
    columnCount: l,
    columnWidth: d,
    pageDimension: r,
    estimatedRowHeight: _,
    estimatedColumnWidth: h
  };
};
let oe;
typeof window < "u" ? oe = window : typeof self < "u" ? oe = self : oe = global;
let _t = null, bt = null;
const Qt = 20, pt = oe.clearTimeout, en = oe.setTimeout, ht = oe.cancelAnimationFrame || oe.mozCancelAnimationFrame || oe.webkitCancelAnimationFrame, tn = oe.requestAnimationFrame || oe.mozRequestAnimationFrame || oe.webkitRequestAnimationFrame;
ht == null || tn == null ? (_t = pt, bt = function(e) {
  return en(e, Qt);
}) : (_t = function([e, n]) {
  ht(e), pt(n);
}, bt = function(e) {
  const n = tn(function() {
    pt(o), e();
  }), o = en(function() {
    ht(n), e();
  }, Qt);
  return [n, o];
});
function Jo(t) {
  let e, n, o, r, a, l, c;
  const d = typeof document < "u" && document.attachEvent;
  if (!d) {
    l = function(S) {
      const u = S.__resizeTriggers__, m = u.firstElementChild, g = u.lastElementChild, s = m.firstElementChild;
      g.scrollLeft = g.scrollWidth, g.scrollTop = g.scrollHeight, s.style.width = m.offsetWidth + 1 + "px", s.style.height = m.offsetHeight + 1 + "px", m.scrollLeft = m.scrollWidth, m.scrollTop = m.scrollHeight;
    }, a = function(S) {
      return S.offsetWidth !== S.__resizeLast__.width || S.offsetHeight !== S.__resizeLast__.height;
    }, c = function(S) {
      if (S.target.className && typeof S.target.className.indexOf == "function" && S.target.className.indexOf("contract-trigger") < 0 && S.target.className.indexOf("expand-trigger") < 0)
        return;
      const u = this;
      l(this), this.__resizeRAF__ && _t(this.__resizeRAF__), this.__resizeRAF__ = bt(function() {
        a(u) && (u.__resizeLast__.width = u.offsetWidth, u.__resizeLast__.height = u.offsetHeight, u.__resizeListeners__.forEach(function(s) {
          s.call(u, S);
        }));
      });
    };
    let h = !1, v = "";
    o = "animationstart";
    const w = "Webkit Moz O ms".split(" ");
    let T = "webkitAnimationStart animationstart oAnimationStart MSAnimationStart".split(" "), P = "";
    {
      const S = document.createElement("fakeelement");
      if (S.style.animationName !== void 0 && (h = !0), h === !1) {
        for (let u = 0; u < w.length; u++)
          if (S.style[w[u] + "AnimationName"] !== void 0) {
            P = w[u], v = "-" + P.toLowerCase() + "-", o = T[u], h = !0;
            break;
          }
      }
    }
    n = "resizeanim", e = "@" + v + "keyframes " + n + " { from { opacity: 0; } to { opacity: 0; } } ", r = v + "animation: 1ms " + n + "; ";
  }
  const p = function(h) {
    if (!h.getElementById("detectElementResize")) {
      const v = (e || "") + ".resize-triggers { " + (r || "") + 'visibility: hidden; opacity: 0; } .resize-triggers, .resize-triggers > div, .contract-trigger:before { content: " "; display: block; position: absolute; top: 0; left: 0; height: 100%; width: 100%; overflow: hidden; z-index: -1; } .resize-triggers > div { background: #eee; overflow: auto; } .contract-trigger:before { width: 200%; height: 200%; }', w = h.head || h.getElementsByTagName("head")[0], T = h.createElement("style");
      T.id = "detectElementResize", T.type = "text/css", t != null && T.setAttribute("nonce", t), T.styleSheet ? T.styleSheet.cssText = v : T.appendChild(h.createTextNode(v)), w.appendChild(T);
    }
  };
  return {
    addResizeListener: function(h, v) {
      if (d)
        h.attachEvent("onresize", v);
      else {
        if (!h.__resizeTriggers__) {
          const w = h.ownerDocument, T = oe.getComputedStyle(h);
          T && T.position === "static" && (h.style.position = "relative"), p(w), h.__resizeLast__ = {}, h.__resizeListeners__ = [], (h.__resizeTriggers__ = w.createElement("div")).className = "resize-triggers";
          const P = w.createElement("div");
          P.className = "expand-trigger", P.appendChild(w.createElement("div"));
          const S = w.createElement("div");
          S.className = "contract-trigger", h.__resizeTriggers__.appendChild(P), h.__resizeTriggers__.appendChild(S), h.appendChild(h.__resizeTriggers__), l(h), h.addEventListener("scroll", c, !0), o && (h.__resizeTriggers__.__animationListener__ = function(m) {
            m.animationName === n && l(h);
          }, h.__resizeTriggers__.addEventListener(o, h.__resizeTriggers__.__animationListener__));
        }
        h.__resizeListeners__.push(v);
      }
    },
    removeResizeListener: function(h, v) {
      if (d)
        h.detachEvent("onresize", v);
      else if (h.__resizeListeners__.splice(h.__resizeListeners__.indexOf(v), 1), !h.__resizeListeners__.length) {
        h.removeEventListener("scroll", c, !0), h.__resizeTriggers__.__animationListener__ && (h.__resizeTriggers__.removeEventListener(o, h.__resizeTriggers__.__animationListener__), h.__resizeTriggers__.__animationListener__ = null);
        try {
          h.__resizeTriggers__ = !h.removeChild(h.__resizeTriggers__);
        } catch {
        }
      }
    }
  };
}
class Qo extends er {
  constructor(...e) {
    super(...e), this.state = {
      height: this.props.defaultHeight || 0,
      scaledHeight: this.props.defaultHeight || 0,
      scaledWidth: this.props.defaultWidth || 0,
      width: this.props.defaultWidth || 0
    }, this._autoSizer = null, this._detectElementResize = null, this._parentNode = null, this._resizeObserver = null, this._timeoutId = null, this._onResize = () => {
      this._timeoutId = null;
      const {
        disableHeight: n,
        disableWidth: o,
        onResize: r
      } = this.props;
      if (this._parentNode) {
        const a = window.getComputedStyle(this._parentNode) || {}, l = parseFloat(a.paddingLeft || "0"), c = parseFloat(a.paddingRight || "0"), d = parseFloat(a.paddingTop || "0"), p = parseFloat(a.paddingBottom || "0"), f = this._parentNode.getBoundingClientRect(), _ = f.height - d - p, h = f.width - l - c, v = this._parentNode.offsetHeight - d - p, w = this._parentNode.offsetWidth - l - c;
        (!n && (this.state.height !== v || this.state.scaledHeight !== _) || !o && (this.state.width !== w || this.state.scaledWidth !== h)) && (this.setState({
          height: v,
          width: w,
          scaledHeight: _,
          scaledWidth: h
        }), typeof r == "function" && r({
          height: v,
          scaledHeight: _,
          scaledWidth: h,
          width: w
        }));
      }
    }, this._setRef = (n) => {
      this._autoSizer = n;
    };
  }
  componentDidMount() {
    const {
      nonce: e
    } = this.props, n = this._autoSizer ? this._autoSizer.parentNode : null;
    if (n != null && n.ownerDocument && n.ownerDocument.defaultView && n instanceof n.ownerDocument.defaultView.HTMLElement) {
      this._parentNode = n;
      const o = n.ownerDocument.defaultView.ResizeObserver;
      o != null ? (this._resizeObserver = new o(() => {
        this._timeoutId = setTimeout(this._onResize, 0);
      }), this._resizeObserver.observe(n)) : (this._detectElementResize = Jo(e), this._detectElementResize.addResizeListener(n, this._onResize)), this._onResize();
    }
  }
  componentWillUnmount() {
    this._parentNode && (this._detectElementResize && this._detectElementResize.removeResizeListener(this._parentNode, this._onResize), this._timeoutId !== null && clearTimeout(this._timeoutId), this._resizeObserver && this._resizeObserver.disconnect());
  }
  render() {
    const {
      children: e,
      defaultHeight: n,
      defaultWidth: o,
      disableHeight: r = !1,
      disableWidth: a = !1,
      doNotBailOutOnEmptyChildren: l = !1,
      nonce: c,
      onResize: d,
      style: p = {},
      tagName: f = "div",
      ..._
    } = this.props, {
      height: h,
      scaledHeight: v,
      scaledWidth: w,
      width: T
    } = this.state, P = {
      overflow: "visible"
    }, S = {};
    let u = !1;
    return r || (h === 0 && (u = !0), P.height = 0, S.height = h, S.scaledHeight = v), a || (T === 0 && (u = !0), P.width = 0, S.width = T, S.scaledWidth = w), l && (u = !1), qe(f, {
      ref: this._setRef,
      style: {
        ...P,
        ...p
      },
      ..._
    }, !u && e(S));
  }
}
const ei = ln(({ widths: t, heights: e }) => {
  const { focusedPage: n, totalPages: o } = ie(), r = k(() => {
    const c = [], d = Math.ceil(n / 2) * 2 - 1;
    if (c.push(d), d + 1 <= o) {
      const p = d + 1;
      c.push(p);
    }
    return c;
  }, [n, o]), a = k(() => {
    const c = n % 2 === 1 ? n - 1 : n - 2, d = t(c), p = e(c), f = t(c + 1), _ = e(c + 1), h = p > _ ? p : _, v = p < _ ? p : _, w = h / 2 - v / 2;
    return [
      {
        position: "absolute",
        left: 0,
        top: h === p ? 0 : w,
        width: d,
        height: p
      },
      {
        position: "absolute",
        left: d,
        top: h === _ ? 0 : w,
        width: f,
        height: _
      }
    ];
  }, [t, e, r]), l = k(() => a.reduce((c, d) => c + Number(d.width || 0), 0), [a]);
  return /* @__PURE__ */ i("div", { style: { width: l, position: "relative" }, children: r.map((c, d) => /* @__PURE__ */ i(xt, { style: a[d], pageNumber: c }, c)) });
}), ti = ({ widths: t, heights: e }) => {
  const { focusedPage: n } = ie(), o = k(() => ({
    position: "absolute",
    width: t(n - 1),
    height: e(n - 1)
  }), [t, e, n]), r = k(() => t(n - 1), [t]);
  return /* @__PURE__ */ i(
    "div",
    {
      style: {
        width: r,
        position: "relative"
      },
      children: /* @__PURE__ */ i(xt, { style: o, pageNumber: n }, n)
    }
  );
}, ni = (t, e, n) => {
  const o = H(), { contentRef: r } = ge(), { heights: a, widths: l } = Ue(), { setFocusedPage: c } = ie(), [d, p] = $([]), { targetScrollPage: f } = pn(), _ = Pt(d, 0, 500), h = k(() => a.map((w, T) => {
    const P = l[T], S = Vr(T + 1, t), u = P * S.columnIndex, m = w * S.rowIndex, g = u + P, s = m + w;
    return {
      pageNumber: T + 1,
      ...S,
      width: P,
      height: w,
      startX: u,
      startY: m,
      endX: g,
      endY: s
    };
  }), [a, l, t, e]);
  W(() => {
    var T;
    _.length > 0 && !f.current && c(_[0].pageNumber);
    let w = (T = _[0]) == null ? void 0 : T.ratio;
    w && _.filter((P) => Math.round(P.ratio) === Math.round(w)).some((P) => P.pageNumber === f.current) && setTimeout(() => {
      f.current = void 0;
    }, 500);
  }, [_, c]);
  const v = N(
    (w) => {
      o.current && cancelAnimationFrame(o.current), o.current = requestAnimationFrame(() => {
        const T = w.target, P = {
          startTop: T.scrollTop,
          startLeft: T.scrollLeft,
          endTop: T.scrollTop + T.clientHeight,
          endLeft: T.scrollLeft + T.clientWidth
        }, S = h.filter((u) => {
          const m = u.endX >= P.startLeft && u.endY >= P.startTop, g = u.startX <= P.endLeft && u.startY <= P.endTop;
          return m && g;
        }).map((u) => {
          const m = P.startLeft > u.startX ? P.startLeft : u.startX, g = P.startTop > u.startY ? P.startTop : u.startY, s = P.endLeft < u.endX ? P.endLeft : u.endX, C = P.endTop < u.endY ? P.endTop : u.endY, b = s - m, y = C - g, I = +(b * y / (u.width * u.height) * 100).toFixed(2);
          return {
            pageNumber: u.pageNumber,
            ratio: I
          };
        }).sort((u, m) => m.ratio - u.ratio);
        p(S);
      });
    },
    [r, h]
  );
  W(() => {
    if (n)
      return n == null || n.addEventListener("scroll", v), () => {
        n == null || n.removeEventListener("scroll", v);
      };
  }, [n, v]);
}, ri = ln(({ columnIndex: t, rowIndex: e, data: n, style: o }) => {
  const r = qr(e, t, n.columnCount);
  return /* @__PURE__ */ i(xt, { style: o, pageNumber: r }, r);
}, Xo), Us = () => {
  const { initialPage: t = 1, initialScrollMode: e, instanceId: n } = ar(), { pagesRef: o, setPagesRef: r } = ge(), { scrollToPage: a } = wn(), {
    virtualScrollRef: l,
    getVirtualScrollRef: c,
    getPageScrollElementRef: d,
    getVirtualScrollableElementRef: p,
    setTotalInnerDimensions: f,
    virtualScrollableElementRef: _,
    totalInnerDimensions: h,
    pageScrollElementRef: v
  } = et(), w = H(!0), { nextPage: T, prevPage: P, setFocusedPage: S, focusedPage: u } = ie(), { scrollMode: m } = Re(), { viewMode: g } = Ee(), s = H(null), { loading: C } = Q(), { passwordRequired: b } = nr(), { LoaderImageComponent: y } = hn(), E = H(
    h
  ), I = H({
    viewMode: g,
    scrollMode: m
  }), L = H(!1), D = H(), { isFullScreen: z } = sr(), {
    pageDimension: A,
    rowCount: R,
    rowHeight: x,
    columnCount: O,
    columnWidth: M,
    estimatedColumnWidth: G,
    estimatedRowHeight: Z
  } = Yo(), j = Pt(h, 100), q = H();
  ni(O, R, _);
  const ee = H({
    scrollTop: 0,
    scrollLeft: 0
  });
  Gr(o);
  const { isPressed: X } = Hr(), { selectionMode: le } = ir(), { initializeGrabScroll: ae, resetGrabState: de } = $r({
    isPressed: X
  }), te = k(() => le === tr.HAND, [le]), Fe = k(() => ({
    columnCount: O
  }), [O]), Ne = N(
    (U) => {
      const V = document.activeElement !== o;
      !z && V || (["ArrowUp", "ArrowLeft"].includes(U.key) ? (U.preventDefault(), P()) : ["ArrowDown", "ArrowRight"].includes(U.key) && (U.preventDefault(), T()));
    },
    [T, P, z, m]
  );
  W(() => (window.addEventListener("keydown", Ne), () => {
    window.removeEventListener("keydown", Ne);
  }), [Ne]), W(() => {
    if (s.current && (s.current.style.position = "relative"), !!l)
      for (let U = 0; U < R; U++)
        for (let V = 0; V < O; V++)
          l.resetAfterIndices({
            columnIndex: V,
            rowIndex: U,
            shouldForceUpdate: !0
          });
  }, [R, O, A, l]);
  const Pe = N(
    (U, V) => {
      if (!_)
        return { scrollTop: 0, scrollLeft: 0 };
      const Te = ee.current.scrollTop > V, Se = ee.current.scrollLeft > U;
      return Te || Se ? ee.current : {
        scrollTop: _.scrollTop,
        scrollLeft: _.scrollLeft
      };
    },
    [_]
  ), we = N(
    (U, V) => {
      if (I.current.viewMode !== g || I.current.scrollMode !== m) {
        q.current && clearTimeout(q.current), L.current = !0, a(u, "auto"), q.current = setTimeout(() => {
          requestAnimationFrame(() => {
            I.current = { viewMode: g, scrollMode: m };
          });
        }, 100);
        return;
      }
      const Se = U.scrollTop, ot = U.scrollLeft;
      if (!V.height || !V.width)
        return;
      L.current = !0;
      const { height: ye, width: it } = V, { height: Ot, width: Dt } = E.current;
      if (Ot === ye && Dt === it)
        return;
      const Kn = Se / Ot * ye, Xn = ot / Dt * it, Yn = Math.round(Math.min(Kn, ye)) || 0, Jn = Math.round(Math.min(Xn, it)) || 0;
      D.current = setTimeout(() => {
        requestAnimationFrame(() => {
          l == null || l.scrollTo({
            scrollTop: Yn,
            scrollLeft: Jn
          });
        });
      }, 0), E.current = {
        height: V.height,
        width: V.width
      };
    },
    [l, g, m, a]
  );
  W(() => {
    clearTimeout(D.current);
    const U = Array.from({ length: R }).reduce(
      (Se, ot, ye) => Se + x(ye),
      0
    ), V = Array.from({ length: O }).reduce(
      (Se, ot, ye) => Se + M(ye),
      0
    ), Te = Pe(V, U);
    ee.current = Te, we(Te, { height: U, width: V }), f({
      height: U,
      width: V
    });
  }, [A, R, O, we]);
  const nt = N(
    (U) => {
      ee.current = {
        scrollTop: U.scrollTop,
        scrollLeft: U.scrollLeft
      };
    },
    [_]
  );
  W(() => () => {
    q.current && clearTimeout(q.current);
  }, []);
  const rt = k(() => ne(ue["rp-pages-container"], {
    [ue["rp-cursor-grab"]]: te && !X,
    [ue["rp-cursor-grabbing"]]: te && X
  }), [te, X]), jn = N(
    (U) => {
      if (te && U) {
        const V = ne(ue["rp-pages"]), Te = document.querySelector(`.${V}`);
        ae(Te);
      }
    },
    [te, ae, ue]
  );
  return W(() => {
    C && de();
  }, [C]), W(() => {
    if (!(j.height === 0 || !w.current)) {
      if (e === J.PAGE_SCROLLING) {
        t !== u && v && S(t), w.current = !1;
        return;
      }
      a(t, "auto"), S(t), w.current = !1;
    }
  }, [
    a,
    e,
    v,
    S,
    j
  ]), /* @__PURE__ */ F(fe, { children: [
    /* @__PURE__ */ i("div", { id: n, ref: r, tabIndex: -1, className: rt, children: /* @__PURE__ */ i(Qo, { style: { minHeight: "50px" }, children: ({ width: U, height: V }) => /* @__PURE__ */ i("div", { "data-rp": "pages", ref: jn, style: { width: U, height: V }, children: m === J.PAGE_SCROLLING ? /* @__PURE__ */ i(
      "div",
      {
        ref: d,
        style: { width: U, height: V },
        className: ne(ue["rp-pages"], ue["rp-page-scrolling-wrapper"]),
        children: g === xe.DUAL_PAGE ? /* @__PURE__ */ i(ei, { widths: M, heights: x }) : /* @__PURE__ */ i(ti, { widths: M, heights: x })
      }
    ) : G ? /* @__PURE__ */ i(
      Zo,
      {
        ref: c,
        itemData: Fe,
        outerRef: p,
        innerRef: s,
        onScroll: nt,
        columnCount: O,
        columnWidth: M,
        rowHeight: x,
        height: V,
        width: U,
        estimatedColumnWidth: G,
        estimatedRowHeight: Z,
        rowCount: R,
        className: ne(
          ue["rp-pages"],
          m === J.HORIZONTAL_SCROLLING ? ue["rp-pages-horizontal-scroll"] : ""
        ),
        children: ri
      }
    ) : C ? null : /* @__PURE__ */ i(
      "div",
      {
        className: ue["rp-loader"],
        style: {
          display: "flex",
          justifyContent: "center",
          alignItems: "center",
          height: "100%",
          width: "100%"
        },
        children: y && /* @__PURE__ */ i(y, {})
      }
    ) }) }) }),
    b && /* @__PURE__ */ i(Ur, {})
  ] });
}, We = {
  "rp-toolbar-content": "_rp-toolbar-content_sz31z_1",
  "rp-toolbar-wrapper": "_rp-toolbar-wrapper_sz31z_10",
  "rp-toolbar-start": "_rp-toolbar-start_sz31z_33",
  "rp-toolbar-middle": "_rp-toolbar-middle_sz31z_39",
  "rp-toolbar-end": "_rp-toolbar-end_sz31z_46"
}, mt = {
  "rp-paginate": "_rp-paginate_1y9vo_1",
  "rp-page-input": "_rp-page-input_1y9vo_6",
  "rp-total-page": "_rp-total-page_1y9vo_11"
}, oi = () => {
  const { prevIcon: t } = pe();
  return t || /* @__PURE__ */ i(He, {});
}, ii = () => {
  const { nextIcon: t } = pe();
  return t || /* @__PURE__ */ i(He, { style: { transform: "rotate(180deg" } });
}, ai = () => {
  const { focusedPage: t, totalPages: e, setFocusedPage: n, nextPage: o, prevPage: r, goToPage: a } = ie(), [l, c] = $(t.toString()), { pageNavigationTool: d = !0 } = ve(), { isSmallScreen: p } = Ce(), { localeMessages: f } = se(), { viewMode: _ } = Ee(), { scrollMode: h } = Re();
  W(() => {
    c(t.toString());
  }, [t]);
  const v = N((u) => {
    const m = u.target.value;
    c(m);
  }, []), w = N(async () => {
    const u = a(l);
    u.success || c(u.currentPage.toString());
  }, [a, l, e]), T = N(() => {
    c(t.toString());
  }, [t]), P = N(
    (u) => {
      u.key === "Enter" && w();
    },
    [w]
  ), S = k(() => _ === xe.DUAL_PAGE && h === J.PAGE_SCROLLING && t === e - 1 || t === e, [t, e, _, h]);
  return typeof d != "boolean" ? /* @__PURE__ */ i(
    d,
    {
      total: e,
      current: t,
      nextPage: o,
      prevPage: r,
      goToPage: a,
      changePage: n
    }
  ) : d ? /* @__PURE__ */ F("div", { className: mt["rp-paginate"], children: [
    !p && /* @__PURE__ */ i(K, { content: f == null ? void 0 : f.previousPageTooltip, children: /* @__PURE__ */ i(
      re,
      {
        onClick: r,
        "aria-label": f == null ? void 0 : f.previousPageTooltip,
        "aria-disabled": t === 1,
        children: /* @__PURE__ */ i(oi, {})
      }
    ) }),
    /* @__PURE__ */ i(K, { content: f == null ? void 0 : f.currentPageTooltip, children: /* @__PURE__ */ i(
      dn,
      {
        onKeyDown: P,
        onBlur: T,
        onChange: v,
        value: l,
        className: mt["rp-page-input"]
      }
    ) }),
    /* @__PURE__ */ F("span", { className: mt["rp-total-page"], children: [
      "/",
      e
    ] }),
    !p && /* @__PURE__ */ i(K, { content: f == null ? void 0 : f.nextPageTooltip, children: /* @__PURE__ */ i(
      re,
      {
        onClick: o,
        "aria-label": f == null ? void 0 : f.nextPageTooltip,
        "aria-disabled": S,
        children: /* @__PURE__ */ i(ii, {})
      }
    ) })
  ] }) : null;
};
var Lt = "Dialog", [xn, Vs] = Xr(Lt), [si, ce] = xn(Lt), Ln = (t) => {
  const {
    __scopeDialog: e,
    children: n,
    open: o,
    defaultOpen: r,
    onOpenChange: a,
    modal: l = !0
  } = t, c = B.useRef(null), d = B.useRef(null), [p = !1, f] = Qr({
    prop: o,
    defaultProp: r,
    onChange: a
  });
  return /* @__PURE__ */ i(
    si,
    {
      scope: e,
      triggerRef: c,
      contentRef: d,
      contentId: ct(),
      titleId: ct(),
      descriptionId: ct(),
      open: p,
      onOpenChange: f,
      onOpenToggle: B.useCallback(() => f((_) => !_), [f]),
      modal: l,
      children: n
    }
  );
};
Ln.displayName = Lt;
var Rn = "DialogTrigger", ci = B.forwardRef(
  (t, e) => {
    const { __scopeDialog: n, ...o } = t, r = ce(Rn, n), a = Tt(e, r.triggerRef);
    return /* @__PURE__ */ i(
      Ve.button,
      {
        type: "button",
        "aria-haspopup": "dialog",
        "aria-expanded": r.open,
        "aria-controls": r.contentId,
        "data-state": Nt(r.open),
        ...o,
        ref: a,
        onClick: Me(t.onClick, r.onOpenToggle)
      }
    );
  }
);
ci.displayName = Rn;
var Rt = "DialogPortal", [li, En] = xn(Rt, {
  forceMount: void 0
}), Nn = (t) => {
  const { __scopeDialog: e, forceMount: n, children: o, container: r } = t, a = ce(Rt, e);
  return /* @__PURE__ */ i(li, { scope: e, forceMount: n, children: B.Children.map(o, (l) => /* @__PURE__ */ i(St, { present: n || a.open, children: /* @__PURE__ */ i(oo, { asChild: !0, container: r, children: l }) })) });
};
Nn.displayName = Rt;
var Xe = "DialogOverlay", On = B.forwardRef(
  (t, e) => {
    const n = En(Xe, t.__scopeDialog), { forceMount: o = n.forceMount, ...r } = t, a = ce(Xe, t.__scopeDialog);
    return a.modal ? /* @__PURE__ */ i(St, { present: o || a.open, children: /* @__PURE__ */ i(di, { ...r, ref: e }) }) : null;
  }
);
On.displayName = Xe;
var di = B.forwardRef(
  (t, e) => {
    const { __scopeDialog: n, ...o } = t, r = ce(Xe, n);
    return (
      // Make sure `Content` is scrollable even when it doesn't live inside `RemoveScroll`
      // ie. when `Overlay` and `Content` are siblings
      /* @__PURE__ */ i(to, { as: Yr, allowPinchZoom: !0, shards: [r.contentRef], children: /* @__PURE__ */ i(
        Ve.div,
        {
          "data-state": Nt(r.open),
          ...o,
          ref: e,
          style: { pointerEvents: "auto", ...o.style }
        }
      ) })
    );
  }
), Le = "DialogContent", Dn = B.forwardRef(
  (t, e) => {
    const n = En(Le, t.__scopeDialog), { forceMount: o = n.forceMount, ...r } = t, a = ce(Le, t.__scopeDialog);
    return /* @__PURE__ */ i(St, { present: o || a.open, children: a.modal ? /* @__PURE__ */ i(ui, { ...r, ref: e }) : /* @__PURE__ */ i(pi, { ...r, ref: e }) });
  }
);
Dn.displayName = Le;
var ui = B.forwardRef(
  (t, e) => {
    const n = ce(Le, t.__scopeDialog), o = B.useRef(null), r = Tt(e, n.contentRef, o);
    return B.useEffect(() => {
      const a = o.current;
      if (a)
        return io(a);
    }, []), /* @__PURE__ */ i(
      zn,
      {
        ...t,
        ref: r,
        trapFocus: n.open,
        disableOutsidePointerEvents: !0,
        onCloseAutoFocus: Me(t.onCloseAutoFocus, (a) => {
          var l;
          a.preventDefault(), (l = n.triggerRef.current) == null || l.focus();
        }),
        onPointerDownOutside: Me(t.onPointerDownOutside, (a) => {
          const l = a.detail.originalEvent, c = l.button === 0 && l.ctrlKey === !0;
          (l.button === 2 || c) && a.preventDefault();
        }),
        onFocusOutside: Me(
          t.onFocusOutside,
          (a) => a.preventDefault()
        )
      }
    );
  }
), pi = B.forwardRef(
  (t, e) => {
    const n = ce(Le, t.__scopeDialog), o = B.useRef(!1), r = B.useRef(!1);
    return /* @__PURE__ */ i(
      zn,
      {
        ...t,
        ref: e,
        trapFocus: !1,
        disableOutsidePointerEvents: !1,
        onCloseAutoFocus: (a) => {
          var l, c;
          (l = t.onCloseAutoFocus) == null || l.call(t, a), a.defaultPrevented || (o.current || (c = n.triggerRef.current) == null || c.focus(), a.preventDefault()), o.current = !1, r.current = !1;
        },
        onInteractOutside: (a) => {
          var d, p;
          (d = t.onInteractOutside) == null || d.call(t, a), a.defaultPrevented || (o.current = !0, a.detail.originalEvent.type === "pointerdown" && (r.current = !0));
          const l = a.target;
          ((p = n.triggerRef.current) == null ? void 0 : p.contains(l)) && a.preventDefault(), a.detail.originalEvent.type === "focusin" && r.current && a.preventDefault();
        }
      }
    );
  }
), zn = B.forwardRef(
  (t, e) => {
    const { __scopeDialog: n, trapFocus: o, onOpenAutoFocus: r, onCloseAutoFocus: a, ...l } = t, c = ce(Le, n), d = B.useRef(null), p = Tt(e, d);
    return no(), /* @__PURE__ */ F(fe, { children: [
      /* @__PURE__ */ i(
        ro,
        {
          asChild: !0,
          loop: !0,
          trapped: o,
          onMountAutoFocus: r,
          onUnmountAutoFocus: a,
          children: /* @__PURE__ */ i(
            eo,
            {
              role: "dialog",
              id: c.contentId,
              "aria-describedby": c.descriptionId,
              "aria-labelledby": c.titleId,
              "data-state": Nt(c.open),
              ...l,
              ref: p,
              onDismiss: () => c.onOpenChange(!1)
            }
          )
        }
      ),
      /* @__PURE__ */ F(fe, { children: [
        /* @__PURE__ */ i(mi, { titleId: c.titleId }),
        /* @__PURE__ */ i(gi, { contentRef: d, descriptionId: c.descriptionId })
      ] })
    ] });
  }
), Et = "DialogTitle", An = B.forwardRef(
  (t, e) => {
    const { __scopeDialog: n, ...o } = t, r = ce(Et, n);
    return /* @__PURE__ */ i(Ve.h2, { id: r.titleId, ...o, ref: e });
  }
);
An.displayName = Et;
var Fn = "DialogDescription", hi = B.forwardRef(
  (t, e) => {
    const { __scopeDialog: n, ...o } = t, r = ce(Fn, n);
    return /* @__PURE__ */ i(Ve.p, { id: r.descriptionId, ...o, ref: e });
  }
);
hi.displayName = Fn;
var Wn = "DialogClose", kn = B.forwardRef(
  (t, e) => {
    const { __scopeDialog: n, ...o } = t, r = ce(Wn, n);
    return /* @__PURE__ */ i(
      Ve.button,
      {
        type: "button",
        ...o,
        ref: e,
        onClick: Me(t.onClick, () => r.onOpenChange(!1))
      }
    );
  }
);
kn.displayName = Wn;
function Nt(t) {
  return t ? "open" : "closed";
}
var Mn = "DialogTitleWarning", [qs, Hn] = Jr(Mn, {
  contentName: Le,
  titleName: Et,
  docsSlug: "dialog"
}), mi = ({ titleId: t }) => {
  const e = Hn(Mn), n = `\`${e.contentName}\` requires a \`${e.titleName}\` for the component to be accessible for screen reader users.

If you want to hide the \`${e.titleName}\`, you can wrap it with our VisuallyHidden component.

For more information, see https://radix-ui.com/primitives/docs/components/${e.docsSlug}`;
  return B.useEffect(() => {
    t && (document.getElementById(t) || console.error(n));
  }, [n, t]), null;
}, fi = "DialogDescriptionWarning", gi = ({ contentRef: t, descriptionId: e }) => {
  const o = `Warning: Missing \`Description\` or \`aria-describedby={undefined}\` for {${Hn(fi).contentName}}.`;
  return B.useEffect(() => {
    var a;
    const r = (a = t.current) == null ? void 0 : a.getAttribute("aria-describedby");
    e && r && (document.getElementById(e) || console.warn(o));
  }, [o, t, e]), null;
}, vi = Ln, wi = Nn, _i = On, bi = Dn, Ci = An, Pi = kn;
const Ie = {
  "rp-dialog-wrapper": "_rp-dialog-wrapper_slqo7_1",
  "rp-dialog-overlay": "_rp-dialog-overlay_slqo7_7",
  "rp-document-dialog": "_rp-document-dialog_slqo7_13",
  "rp-document-properties": "_rp-document-properties_slqo7_35",
  "rp-dialog-title": "_rp-dialog-title_slqo7_39",
  "rp-dialog-close": "_rp-dialog-close_slqo7_47",
  "rp-properties-divider": "_rp-properties-divider_slqo7_55"
}, Ti = () => {
  const { pdfProperties: t } = Q(), { container: e } = ge(), { activeDocumentProperties: n, setActiveDocumentProperties: o } = co(), { localeMessages: r } = se(), a = k(() => {
    if (!t)
      return [];
    const {
      fileSize: l,
      filename: c,
      title: d,
      author: p,
      subject: f,
      createdOn: _,
      creator: h,
      keywords: v,
      modifiedOn: w,
      pdfProducer: T,
      pdfVersion: P,
      pageCount: S
    } = t;
    return [
      { label: r == null ? void 0 : r.propertiesFilenameLabel, value: c },
      { label: r == null ? void 0 : r.propertiesFileSizeLabel, value: l },
      { separate: !0 },
      { label: r == null ? void 0 : r.propertiesTitleLabel, value: d },
      { label: r == null ? void 0 : r.propertiesAuthorLabel, value: p },
      { label: r == null ? void 0 : r.propertiesSubjectLabel, value: f },
      { label: r == null ? void 0 : r.propertiesKeywordLabel, value: v },
      { label: r == null ? void 0 : r.propertiesCreatorLabel, value: h },
      {
        label: r == null ? void 0 : r.propertiesCreateOnLabel,
        value: _ ? kt(_) : ""
      },
      {
        label: r == null ? void 0 : r.propertiesModifiedOnLabel,
        value: w ? kt(w) : ""
      },
      { separate: !0 },
      { label: r == null ? void 0 : r.propertiesPDFProducerLabel, value: T },
      { label: r == null ? void 0 : r.propertiesPDFVersionLabel, value: P },
      { label: r == null ? void 0 : r.propertiesPageCountLabel, value: S }
    ];
  }, [t, r]);
  return /* @__PURE__ */ i(vi, { open: n, onOpenChange: o, children: /* @__PURE__ */ i(wi, { container: e, children: /* @__PURE__ */ F("div", { className: Ie["rp-dialog-wrapper"], children: [
    /* @__PURE__ */ i(_i, { className: Ie["rp-dialog-overlay"] }),
    /* @__PURE__ */ F(bi, { className: Ie["rp-document-dialog"], children: [
      /* @__PURE__ */ i(Ci, { className: Ie["rp-dialog-title"], children: r == null ? void 0 : r.documentPropertiesLabel }),
      /* @__PURE__ */ i("div", { className: Ie["rp-document-properties"], children: a.map((l, c) => /* @__PURE__ */ i("div", { children: l.separate ? /* @__PURE__ */ i("div", { className: Ie["rp-properties-divider"] }) : /* @__PURE__ */ i(so, { label: l.label, value: l.value }) }, c)) }),
      /* @__PURE__ */ i(Pi, { asChild: !0, className: Ie["rp-dialog-close"], children: /* @__PURE__ */ i(ao, {}) })
    ] })
  ] }) }) });
}, Si = {
  "rp-other-tool-content": "_rp-other-tool-content_su718_1"
}, nn = ".pdf", yi = (t) => URL.createObjectURL(t), Ii = async (t) => {
  const n = await (await fetch(t)).blob();
  return yi(n);
}, $n = () => {
  const { filename: t, pdfSrc: e } = Q(), { downloadFilename: n } = hr(), o = (a) => {
    const l = n || a;
    return l.endsWith(nn) ? l : `${l}${nn}`;
  };
  return { download: N(async () => {
    if (!t || !e)
      throw new Error("There is no PDF source to download");
    const a = document.createElement("a");
    a.href = await Ii(e), a.download = o(t), document.body.appendChild(a), a.click(), document.body.removeChild(a);
  }, [t, e]) };
}, Gn = () => {
  const { downloadIcon: t } = pe();
  return t || /* @__PURE__ */ i(fo, {});
}, Un = ({ children: t, className: e, localeMessages: n }) => /* @__PURE__ */ i(K, { className: e, content: n == null ? void 0 : n.downloadFileTooltip, children: t }), xi = ({ download: t, localeMessages: e }) => /* @__PURE__ */ i(Un, { localeMessages: e, children: /* @__PURE__ */ i(re, { onClick: t, "aria-label": e == null ? void 0 : e.downloadFileTooltip, children: /* @__PURE__ */ i(Gn, {}) }) }), Li = ({ download: t, localeMessages: e }) => /* @__PURE__ */ i(be, { onClick: t, children: /* @__PURE__ */ F(Un, { className: "rp-menu-item", localeMessages: e, children: [
  /* @__PURE__ */ i("div", { className: "rp-menu-item-left", children: /* @__PURE__ */ i(Gn, {}) }),
  e == null ? void 0 : e.downloadFileLabel
] }) }), Vn = () => {
  const { download: t } = $n(), { downloadTool: e = !0 } = ve(), { isSmallScreen: n } = Ce(), { localeMessages: o } = se();
  return e ? n ? /* @__PURE__ */ i(Li, { download: t, localeMessages: o }) : typeof e == "function" ? /* @__PURE__ */ i(e, { download: t }) : e ? /* @__PURE__ */ i(xi, { download: t, localeMessages: o }) : null : null;
}, qn = () => {
  const { printIcon: t } = pe();
  return t || /* @__PURE__ */ i(go, {});
}, Bn = ({ children: t, className: e, localeMessages: n }) => /* @__PURE__ */ i(K, { className: e, content: n == null ? void 0 : n.printTooltip, children: t }), Ri = ({ print: t, localeMessages: e }) => /* @__PURE__ */ i(Bn, { localeMessages: e, children: /* @__PURE__ */ i(re, { onClick: t, "aria-label": e == null ? void 0 : e.printTooltip, children: /* @__PURE__ */ i(qn, {}) }) }), Ei = ({ print: t, localeMessages: e }) => /* @__PURE__ */ i(be, { onClick: t, children: /* @__PURE__ */ F(Bn, { className: "rp-menu-item", localeMessages: e, children: [
  /* @__PURE__ */ i("div", { className: "rp-menu-item-left", children: /* @__PURE__ */ i(qn, {}) }),
  e == null ? void 0 : e.printLabel
] }) }), Zn = () => {
  const { print: t, cancel: e, setOnProgress: n, setOnComplete: o, setOnError: r, progress: a } = tt(), { printTool: l = !0 } = ve(), { isSmallScreen: c } = Ce(), { localeMessages: d } = se();
  return l ? c ? /* @__PURE__ */ i(Ei, { print: t, localeMessages: d }) : typeof l == "function" ? /* @__PURE__ */ i(
    l,
    {
      print: t,
      cancel: e,
      setOnProgress: n,
      setOnError: r,
      setOnComplete: o,
      progress: a
    }
  ) : l ? /* @__PURE__ */ i(Ri, { print: t, localeMessages: d }) : null : null;
}, Ni = {
  "rp-go-to-Top": "_rp-go-to-Top_4e0yd_1"
}, Oi = () => {
  const { goToFirstPageIcon: t } = pe();
  return t || /* @__PURE__ */ i(vn, { className: Ni["rp-go-to-Top"] });
}, Di = () => {
  const { goToLastPageIcon: t } = pe();
  return t || /* @__PURE__ */ i(vn, {});
}, rn = { width: "100%" }, zi = () => {
  const { goToPage: t, totalPages: e, focusedPage: n } = ie(), { jumpNavigationTool: o = !0 } = ve(), { localeMessages: r } = se(), a = k(() => n === 1, [n]), l = k(() => n === e, [n, e]), c = N(() => {
    t(1);
  }, [t]), d = N(() => {
    t(e);
  }, [t, e]);
  return o ? /* @__PURE__ */ F(Ke, { children: [
    /* @__PURE__ */ i(be, { onClick: c, children: /* @__PURE__ */ i(K, { content: r == null ? void 0 : r.firstPageTooltip, style: rn, children: /* @__PURE__ */ F("div", { className: "rp-menu-item", "aria-disabled": a, children: [
      /* @__PURE__ */ i("div", { className: "rp-menu-item-left", children: /* @__PURE__ */ i(Oi, {}) }),
      /* @__PURE__ */ i("span", { children: r == null ? void 0 : r.firstPageLabel })
    ] }) }) }),
    /* @__PURE__ */ i(be, { onClick: d, children: /* @__PURE__ */ i(K, { content: r == null ? void 0 : r.lastPageTooltip, style: rn, children: /* @__PURE__ */ F("div", { className: "rp-menu-item", "aria-disabled": l, children: [
      /* @__PURE__ */ i("div", { className: "rp-menu-item-left", children: /* @__PURE__ */ i(Di, {}) }),
      /* @__PURE__ */ i("span", { children: r == null ? void 0 : r.lastPageLabel })
    ] }) }) }),
    /* @__PURE__ */ i(yt, {})
  ] }) : null;
}, Ai = () => {
  const { container: t } = ge(), { isSmallScreen: e } = Ce(), {
    openFileTool: n,
    downloadTool: o,
    documentProperties: r,
    scrollModeTool: a,
    rotateTool: l,
    selectionModeTool: c,
    jumpNavigationTool: d,
    printTool: p,
    fullscreenTool: f
  } = ve(), { localeMessages: _ } = se();
  return k(() => {
    const v = d || l || c || a || r;
    let w = !1;
    return e && (w = !(!n && !o && !p && !f)), v || w;
  }, [
    n,
    o,
    r,
    a,
    l,
    c,
    d,
    e
  ]) ? /* @__PURE__ */ F(lo, { children: [
    /* @__PURE__ */ i(
      fn,
      {
        container: t,
        triggerComponent: /* @__PURE__ */ i("div", { role: "button", children: /* @__PURE__ */ i(K, { content: _ == null ? void 0 : _.moreOptionTooltip, children: /* @__PURE__ */ i(re, { "aria-label": _ == null ? void 0 : _.moreOptionTooltip, children: /* @__PURE__ */ i(Kr, {}) }) }) }),
        children: /* @__PURE__ */ F("div", { className: Si["rp-other-tool-content"], "data-rp": "moreOptionsDropdown", children: [
          e && /* @__PURE__ */ F(Ke, { children: [
            /* @__PURE__ */ i(mn, {}),
            /* @__PURE__ */ i(Vn, {}),
            /* @__PURE__ */ i(Zn, {}),
            /* @__PURE__ */ i(gn, {}),
            /* @__PURE__ */ i(yt, {})
          ] }),
          /* @__PURE__ */ i(zi, {}),
          /* @__PURE__ */ i(po, {}),
          /* @__PURE__ */ i(vo, {}),
          /* @__PURE__ */ i(ho, {}),
          /* @__PURE__ */ i(mo, {}),
          /* @__PURE__ */ i(uo, {})
        ] })
      }
    ),
    /* @__PURE__ */ i(Ti, {})
  ] }) : null;
}, Fi = () => {
  const { isSmallScreen: t } = Ce();
  return /* @__PURE__ */ F(fe, { children: [
    /* @__PURE__ */ i(jr, {}),
    !t && /* @__PURE__ */ F(fe, { children: [
      /* @__PURE__ */ i(mn, {}),
      /* @__PURE__ */ i(Vn, {}),
      /* @__PURE__ */ i(Zn, {}),
      /* @__PURE__ */ i(gn, {})
    ] }),
    /* @__PURE__ */ i(Ai, {})
  ] });
}, De = {
  "rp-zoom-wrapper": "_rp-zoom-wrapper_cocqs_1",
  "rp-current-zoom-wrapper": "_rp-current-zoom-wrapper_cocqs_6",
  "rp-current-zoom-icon": "_rp-current-zoom-icon_cocqs_11",
  "rp-current-zoom-text": "_rp-current-zoom-text_cocqs_16",
  "rp-zoom-dropdown-content": "_rp-zoom-dropdown-content_cocqs_20"
}, Wi = 25, ft = 1e3, ki = [50, 75, 100, 125, 150, 200, 300, 400], Mi = () => {
  const { zoomInIcon: t } = pe();
  return t || /* @__PURE__ */ i(wo, {});
}, Hi = () => {
  const { zoomOutIcon: t } = pe();
  return t || /* @__PURE__ */ i(_o, {});
}, $i = () => {
  const { zoomLevel: t, setZoomLevel: e } = Qe(), { container: n, pagesRef: o } = ge(), { zoomTool: r = !0 } = ve(), { focusedPage: a } = ie(), { rotate: l } = Ge(), { pages: c } = Q(), { isSmallScreen: d } = Ce(), { localeMessages: p } = se(), { viewMode: f } = Ee(), _ = N(() => {
    e((u) => {
      const m = Math.floor(u / 25) * 25;
      return Math.min(m + 25, ft);
    });
  }, [e]), h = N(() => {
    e((u) => {
      const m = Math.ceil(u / 25) * 25;
      return Math.min(m - 25, ft);
    });
  }, [e]), v = k(() => t === Wi, [t]), w = k(() => t === ft, [t]), T = k(() => {
    var u;
    return (u = c.get(a)) == null ? void 0 : u.page.getViewport({ scale: 1, rotation: l });
  }, [c, a, l]), P = N(
    (u) => {
      const m = ((T == null ? void 0 : T.width) || 0) + 2 * Mt, g = ((T == null ? void 0 : T.height) || 0) + 2 * Mt, s = (o == null ? void 0 : o.clientWidth) || 0, C = (o == null ? void 0 : o.clientHeight) || 0, b = bo(
        u,
        s,
        C,
        m,
        g,
        f
      );
      e(b);
    },
    [e, T, o]
  ), S = N(
    (u) => {
      typeof u == "number" ? e(u) : P(u);
    },
    [e, P]
  );
  return typeof r != "boolean" ? /* @__PURE__ */ i(r, { zoomLevel: t, setZoomLevel: e }) : r ? /* @__PURE__ */ F("div", { className: De["rp-zoom-wrapper"], children: [
    /* @__PURE__ */ i(K, { content: p == null ? void 0 : p.zoomOutTooltip, children: /* @__PURE__ */ i(
      re,
      {
        disabled: v,
        onClick: h,
        "aria-label": p == null ? void 0 : p.zoomOutTooltip,
        children: /* @__PURE__ */ i(Hi, {})
      }
    ) }),
    !d && /* @__PURE__ */ i(
      fn,
      {
        container: n,
        triggerComponent: /* @__PURE__ */ i("div", { role: "button", children: /* @__PURE__ */ i(K, { content: p == null ? void 0 : p.zoomSelectTooltip, children: /* @__PURE__ */ F(
          re,
          {
            className: De["rp-current-zoom-wrapper"],
            "aria-label": p == null ? void 0 : p.zoomSelectTooltip,
            children: [
              /* @__PURE__ */ i("span", { className: De["rp-current-zoom-text"], children: t }),
              /* @__PURE__ */ i("span", { className: De["rp-current-zoom-text"], children: "%" }),
              /* @__PURE__ */ i(He, { className: De["rp-current-zoom-icon"] })
            ]
          }
        ) }) }),
        style: { minWidth: "200px" },
        align: "center",
        children: /* @__PURE__ */ F("div", { className: De["rp-zoom-dropdown-content"], children: [
          /* @__PURE__ */ F(Ke, { children: [
            /* @__PURE__ */ i(be, { onClick: () => S(at.ACTUAL), children: p == null ? void 0 : p.zoomActualSize }),
            /* @__PURE__ */ i(be, { onClick: () => S(at.PAGE_FIT), children: p == null ? void 0 : p.zoomPageFit }),
            /* @__PURE__ */ i(be, { onClick: () => S(at.PAGE_WIDTH), children: p == null ? void 0 : p.zoomPageWidth })
          ] }),
          /* @__PURE__ */ i(yt, {}),
          /* @__PURE__ */ i(Ke, { children: ki.map((u) => /* @__PURE__ */ F(be, { onClick: () => S(u), children: [
            u,
            " %"
          ] }, u)) })
        ] })
      }
    ),
    /* @__PURE__ */ i(K, { content: p == null ? void 0 : p.zoomInTooltip, children: /* @__PURE__ */ i(
      re,
      {
        disabled: w,
        onClick: _,
        "aria-label": p == null ? void 0 : p.zoomInTooltip,
        children: /* @__PURE__ */ i(Mi, {})
      }
    ) })
  ] }) : null;
}, on = () => {
  const {
    totalMatches: t,
    nextMatch: e,
    prevMatch: n
  } = It(), { localeMessages: o } = se();
  return /* @__PURE__ */ F(fe, { children: [
    /* @__PURE__ */ i(K, { content: o == null ? void 0 : o.searchPrevTooltip, className: Y["rp-search-tool-result-navigator"], children: /* @__PURE__ */ i(re, { onClick: n, "aria-label": o == null ? void 0 : o.searchPrevTooltip, children: /* @__PURE__ */ i(
      He,
      {
        className: Y["rp-search-tool-input-icon"],
        "aria-disabled": !t
      }
    ) }) }),
    /* @__PURE__ */ i(K, { content: o == null ? void 0 : o.searchNextTooltip, className: Y["rp-search-tool-result-navigator"], children: /* @__PURE__ */ i(re, { onClick: e, "aria-label": o == null ? void 0 : o.searchNextTooltip, children: /* @__PURE__ */ i(
      He,
      {
        style: { transform: "rotate(180deg" },
        className: Y["rp-search-tool-input-icon"],
        "aria-disabled": !t
      }
    ) }) })
  ] });
}, an = () => {
  const { searchIcon: t } = pe();
  return t || /* @__PURE__ */ i(Co, {});
}, Gi = () => {
  const { container: t } = ge(), [e, n] = $(!1), { pdf: o } = Q(), [r, a] = $(null), {
    searchOptions: l,
    setSearchOptions: c,
    loading: d,
    setSearch: p,
    totalMatches: f,
    currentMatchPosition: _,
    nextMatch: h,
    prevMatch: v,
    search: w
  } = It(), { searchTool: T = !0 } = ve(), [P, S] = $(w), { localeMessages: u } = se(), { isSmallScreen: m } = Ce(), g = N(() => {
    n(!0);
  }, []), s = N(() => {
    p(""), S(""), n(!1);
  }, [p]), C = (x) => {
    const O = x.key === "Enter", M = x.key === " ";
    (O || M) && s();
  }, b = N(
    (x) => {
      x.key === "Escape" && e && s();
    },
    [e]
  ), y = N(
    (x) => {
      x.shiftKey && x.key === "Enter" ? v() : x.key === "Enter" && w !== P ? p(P) : x.key === "Enter" && h();
    },
    [P, v, h, p, w]
  );
  W(() => (window.addEventListener("keydown", b), () => {
    window.removeEventListener("keydown", b);
  }), [b]), W(() => {
    r && r.focus();
  }, [r]);
  const E = N((x) => {
    S(x.target.value);
  }, []), I = N(() => {
    S(""), p("");
  }, [p]), L = k(() => `${_} / ${f}`, [_, f]), { wholeWords: D, matchCase: z } = k(() => l, [l]), A = N(
    (x) => {
      c((O) => ({ ...O, matchCase: x }));
    },
    [c]
  ), R = N(
    (x) => {
      c((O) => ({ ...O, wholeWords: x }));
    },
    [c]
  );
  return W(() => {
    s();
  }, [o, s]), T ? /* @__PURE__ */ i(fe, { children: /* @__PURE__ */ i(
    Mr,
    {
      open: e,
      container: t,
      triggerComponent: /* @__PURE__ */ i(K, { content: u == null ? void 0 : u.searchButtonTooltip, children: /* @__PURE__ */ i(re, { onClick: g, "aria-label": u == null ? void 0 : u.searchButtonTooltip, children: /* @__PURE__ */ i(an, {}) }) }),
      children: /* @__PURE__ */ F("div", { className: Y["rp-search-tool-content"], children: [
        /* @__PURE__ */ F("div", { className: Y["rp-search-tool-input-wrapper"], children: [
          /* @__PURE__ */ F("div", { className: Y["rp-search-tool-input"], children: [
            /* @__PURE__ */ i(K, { content: u == null ? void 0 : u.searchInputTooltip, children: /* @__PURE__ */ i(
              dn,
              {
                value: P,
                onKeyDown: y,
                onChange: E,
                icon: /* @__PURE__ */ i(an, {}),
                placeholder: u == null ? void 0 : u.searchInputPlaceholder,
                className: Y["rp-search-input"],
                ref: a,
                children: !!P && /* @__PURE__ */ i("span", { className: Y["rp-search-tool-input-clear"], onClick: I, children: /* @__PURE__ */ i(Po, {}) })
              }
            ) }),
            d ? /* @__PURE__ */ i("span", { children: /* @__PURE__ */ i(Ct, { className: Y["rp-search-loader-icon"] }) }) : /* @__PURE__ */ i("span", { children: L }),
            m && /* @__PURE__ */ i("div", { className: Y["rp-search-tool-controls"], children: /* @__PURE__ */ i(Ht, { onKeyPress: C, handleClose: s }) })
          ] }),
          /* @__PURE__ */ F("div", { className: Y["rp-search-tool-input-checkboxes"], children: [
            m && /* @__PURE__ */ i(on, {}),
            /* @__PURE__ */ i($t, { name: "matchCase", value: z, onChange: A, children: u == null ? void 0 : u.searchMatchCaseLabel }),
            !m && /* @__PURE__ */ i(K, { content: u == null ? void 0 : u.searchMatchCaseTooltip, children: /* @__PURE__ */ i("div", { className: Y["rp-search-icon-info"], tabIndex: 0, children: /* @__PURE__ */ i(Gt, {}) }) }),
            /* @__PURE__ */ i($t, { name: "wholeWord", value: D, onChange: R, children: u == null ? void 0 : u.searchWholeWordsLabel }),
            !m && /* @__PURE__ */ i(K, { content: u == null ? void 0 : u.searchWholeWordsTooltip, children: /* @__PURE__ */ i("div", { className: Y["rp-search-icon-info"], tabIndex: 0, children: /* @__PURE__ */ i(Gt, {}) }) })
          ] })
        ] }),
        !m && /* @__PURE__ */ F("div", { className: Y["rp-search-tool-controls"], children: [
          /* @__PURE__ */ i(on, {}),
          /* @__PURE__ */ i(Ht, { onKeyPress: C, handleClose: s })
        ] })
      ] })
    }
  ) }) : null;
}, Ui = "_loading_wazy2_1", ze = {
  "rp-loading-overlay": "_rp-loading-overlay_wazy2_1",
  "rp-loading-modal": "_rp-loading-modal_wazy2_14",
  "rp-loading-title": "_rp-loading-title_wazy2_27",
  "rp-loading-progress-bar": "_rp-loading-progress-bar_wazy2_35",
  "rp-loading-progress": "_rp-loading-progress_wazy2_35",
  "rp-loading-cancel-button": "_rp-loading-cancel-button_wazy2_55",
  loading: Ui
}, Vi = ({ percentage: t }) => {
  const { cancel: e } = tt(), { localeMessages: n } = se();
  return t < 1 ? null : /* @__PURE__ */ i("div", { className: ne(ze["rp-loading-overlay"]), children: /* @__PURE__ */ F("div", { className: ne(ze["rp-loading-modal"]), children: [
    /* @__PURE__ */ F("div", { className: ne(ze["rp-loading-title"]), children: [
      n == null ? void 0 : n.printLoadingMessage,
      "..."
    ] }),
    /* @__PURE__ */ i("div", { className: ne(ze["rp-loading-progress-bar"]), children: /* @__PURE__ */ i(
      "div",
      {
        className: ne(ze["rp-loading-progress"]),
        style: { width: `${t}%` }
      }
    ) }),
    /* @__PURE__ */ i("button", { className: ne(ze["rp-loading-cancel-button"]), onClick: e, children: n == null ? void 0 : n.printCancelLabel })
  ] }) });
}, qi = $e((t, e) => {
  const { showPrintProgress: n } = ve(), { progress: o } = tt(), { isSmallScreen: r } = Ce(), { percentage: a } = o || {}, l = () => r ? { gridTemplateColumns: "25% 60% 15%" } : void 0;
  return /* @__PURE__ */ F("div", { children: [
    /* @__PURE__ */ i("div", { "data-rp": "topBar", ref: e, className: We["rp-toolbar-content"], children: /* @__PURE__ */ F("div", { className: We["rp-toolbar-wrapper"], style: l(), children: [
      /* @__PURE__ */ F("div", { "data-rp": "topBarLeft", className: We["rp-toolbar-start"], children: [
        /* @__PURE__ */ i(Gi, {}),
        /* @__PURE__ */ i(ai, {})
      ] }),
      /* @__PURE__ */ i("div", { "data-rp": "topBarCenter", className: We["rp-toolbar-middle"], children: /* @__PURE__ */ i($i, {}) }),
      /* @__PURE__ */ i("div", { "data-rp": "topBarRight", className: We["rp-toolbar-end"], children: /* @__PURE__ */ i(Fi, {}) })
    ] }) }),
    n && a ? /* @__PURE__ */ i(Vi, { percentage: a }) : null
  ] });
}), gt = {
  "rp-sidebar-content-wrapper": "_rp-sidebar-content-wrapper_1sdl6_1",
  "rp-sidebar-content": "_rp-sidebar-content_1sdl6_1",
  "rp-thumbnails-wrapper": "_rp-thumbnails-wrapper_1sdl6_16",
  "rp-thumbnail-dragging": "_rp-thumbnail-dragging_1sdl6_21"
}, ke = {
  "rp-thumbnail-wrapper": "_rp-thumbnail-wrapper_3fenb_1",
  "rp-thumbnail-text": "_rp-thumbnail-text_3fenb_10",
  "rp-thumbnail": "_rp-thumbnail_3fenb_1",
  "rp-thumbnail-active": "_rp-thumbnail-active_3fenb_22",
  "rp-thumbnail-loader": "_rp-thumbnail-loader_3fenb_31"
}, Bi = (t) => {
  const { thumbnailSrc: e, pageNumber: n, isFocused: o, viewport: r } = t, { goToPage: a } = ie(), l = k(() => o ? ke["rp-thumbnail-active"] : "", [o]), c = k(() => ({
    width: Math.round(r.width),
    height: Math.round(r.height)
  }), [r]), d = N(() => {
    n && a(n);
  }, [a, n]);
  return /* @__PURE__ */ F(
    "div",
    {
      onClick: d,
      id: `page-${n}`,
      className: ke["rp-thumbnail-wrapper"],
      children: [
        /* @__PURE__ */ i("div", { className: ne(l, ke["rp-thumbnail"]), children: e ? /* @__PURE__ */ i(
          "img",
          {
            src: e,
            width: c.width,
            height: c.height,
            alt: "thumbnail"
          }
        ) : /* @__PURE__ */ i(
          "div",
          {
            className: ke["rp-thumbnail-loader"],
            style: {
              width: `${c.width}px`,
              height: `${c.height}px`
            },
            children: /* @__PURE__ */ i(Ct, {})
          }
        ) }),
        /* @__PURE__ */ i("div", { className: ke["rp-thumbnail-text"], children: n })
      ]
    }
  );
}, sn = {
  "rp-thumbnails-container": "_rp-thumbnails-container_16vqr_1",
  "rp-thumbnails": "_rp-thumbnails_16vqr_1"
}, Zi = 16, ji = (t, e) => {
  const n = t == null ? void 0 : t.querySelector(`#page-${e}`);
  t && (n != null && n.offsetTop) && (t.scrollTop = (n == null ? void 0 : n.offsetTop) - Zi);
}, Ki = $e((t, e) => {
  const { show: n } = t, { focusedPage: o, totalPages: r } = ie(), { thumbnailPages: a, addPage: l, thumbnailLength: c, addToPage: d } = Pn(), p = H(null), f = H(1);
  cn(e, () => p.current);
  const _ = k(() => Object.values(a), [a]), h = N(() => {
    const v = c + 1;
    v <= r && l(v);
  }, [l, r, c]);
  return W(() => {
    o > c ? d(o) : n && f.current !== o && (ji(p.current, o), f.current = o);
  }, [o, c, d, n, _]), fr(p.current, h), /* @__PURE__ */ i("div", { ref: p, className: sn["rp-thumbnails-container"], children: /* @__PURE__ */ i("div", { className: sn["rp-thumbnails"], children: n ? _.map((v, w) => {
    var T, P;
    return /* @__PURE__ */ i(
      Bi,
      {
        isFocused: o === ((T = v.page) == null ? void 0 : T.pageNumber),
        pageNumber: (P = v.page) == null ? void 0 : P.pageNumber,
        thumbnailSrc: v.thumbnailSrc,
        loading: v.loading,
        viewport: v.viewport
      },
      w
    );
  }) : null }) });
}), Xi = () => {
  const { thumbnailIcon: t } = pe();
  return t || /* @__PURE__ */ i(mr, {});
}, Yi = () => {
  const { active: t, setActive: e } = Pn(), [n, o] = $(200), r = H(null), { thumbnailTool: a, sidebarEnable: l } = ve(), { localeMessages: c } = se(), d = N(() => {
    e((f) => !f);
  }, []), p = k(() => typeof a != "boolean" && a ? /* @__PURE__ */ i(a, { onClick: d, active: t }) : a ? /* @__PURE__ */ i(K, { content: c == null ? void 0 : c.thumbnailTooltip, children: /* @__PURE__ */ i(
    re,
    {
      onClick: d,
      active: t,
      "aria-label": c == null ? void 0 : c.thumbnailTooltip,
      children: /* @__PURE__ */ i(Xi, {})
    }
  ) }) : null, [a, t, d, c]);
  return /* @__PURE__ */ i(fe, { children: l && /* @__PURE__ */ F(
    "div",
    {
      style: { "--rp-thumbnail-width": `${n}px` },
      className: gt["rp-sidebar-content-wrapper"],
      "data-rp": "sidebar",
      children: [
        /* @__PURE__ */ i("div", { className: gt["rp-sidebar-content"], children: p }),
        /* @__PURE__ */ F(
          "div",
          {
            "data-rp": "thumbnailSidebar",
            hidden: !t,
            className: gt["rp-thumbnails-wrapper"],
            children: [
              /* @__PURE__ */ i(Ki, { show: t, ref: r }),
              /* @__PURE__ */ i(gr, { onWidthChange: o, thumbnailRef: r })
            ]
          }
        )
      ]
    }
  ) });
}, _e = {
  "rp-layout": "_rp-layout_ah61i_1",
  "rp-content": "_rp-content_ah61i_5",
  "rp-pages": "_rp-pages_ah61i_11",
  "rp-container": "_rp-container_ah61i_16",
  "rp-loader": "_rp-loader_ah61i_52",
  "rp-theme-variables": "_rp-theme-variables_ah61i_56",
  "rp-dark-mode": "_rp-dark-mode_ah61i_167"
}, Ji = $e(
  (t, e) => {
    const { children: n, toolbarRef: o, style: r, className: a } = t, { customVariables: l, customDarkVariables: c } = Tr(), { darkMode: d } = rr();
    return /* @__PURE__ */ i(
      "div",
      {
        ref: e,
        className: ne(
          _e["rp-theme-variables"],
          _e["rp-container"],
          d ? _e["rp-dark-mode"] : "",
          a
        ),
        style: {
          "--rp-toolbar-height": `${(o == null ? void 0 : o.clientHeight) || 48}px`,
          ...l,
          ...d ? c : {},
          ...r
        },
        children: n
      }
    );
  }
), Bs = $e((t, e) => {
  const {
    children: n,
    slots: o,
    icons: r,
    style: a,
    className: l,
    mobileWidth: c,
    onLoaded: d,
    cleanupOnLoaded: p,
    onLayoutWidthChange: f
  } = t, [_, h] = $(null), { setContainer: v, setContentRef: w } = ge(), { loading: T } = Q(), { LoaderImageComponent: P } = hn();
  return W(() => (d && d(), () => {
    p && p();
  }), [d, p]), /* @__PURE__ */ i(Ji, { toolbarRef: _, ref: e, children: /* @__PURE__ */ i(Pr, { mobileWidth: c, onLayoutWidthChange: f, children: /* @__PURE__ */ i(vr, { slots: o, children: /* @__PURE__ */ i(wr, { icons: r, children: /* @__PURE__ */ F(_r, { getContainerRef: v, style: a, className: l, children: [
    /* @__PURE__ */ F(br, { children: [
      /* @__PURE__ */ F("div", { className: _e["rp-layout"], children: [
        /* @__PURE__ */ i(qi, { ref: h }),
        /* @__PURE__ */ F("div", { className: _e["rp-content"], children: [
          /* @__PURE__ */ i("div", { className: _e["rp-sidebar"], children: /* @__PURE__ */ i(Yi, {}) }),
          /* @__PURE__ */ i("div", { ref: w, className: _e["rp-pages"], children: n })
        ] })
      ] }),
      /* @__PURE__ */ i(Cr, {})
    ] }),
    T ? /* @__PURE__ */ i(
      "div",
      {
        className: _e["rp-loader"],
        style: {
          position: "absolute",
          top: 0,
          left: 0,
          right: 0,
          bottom: 0,
          width: "100%",
          height: "100%"
        },
        children: /* @__PURE__ */ i(
          "div",
          {
            style: {
              display: "flex",
              justifyContent: "center",
              alignItems: "center",
              height: "100%",
              width: "100%"
            },
            children: P && /* @__PURE__ */ i(P, {})
          }
        )
      }
    ) : null
  ] }) }) }) }) });
});
export {
  Do as A,
  on as B,
  xo as C,
  ei as D,
  Gi as E,
  Vn as F,
  qi as G,
  Bi as H,
  Ki as I,
  Yi as J,
  Ji as K,
  Vi as L,
  zi as M,
  Ai as O,
  Ms as P,
  Us as R,
  Gs as S,
  $s as T,
  $i as Z,
  Hs as a,
  Bs as b,
  $n as c,
  tt as d,
  It as e,
  wn as f,
  To as g,
  _n as h,
  So as i,
  bn as j,
  yo as k,
  Cn as l,
  Pn as m,
  Io as n,
  Tn as o,
  Eo as p,
  Ao as q,
  xt as r,
  Yo as s,
  ti as t,
  ie as u,
  ni as v,
  ai as w,
  Ti as x,
  Zn as y,
  Fi as z
};
