import { FC, PropsWithChildren } from 'react';
import { DocumentContextType, RPSrc, CharacterMap, LoadPDFOptions } from '../utils/types';
import { PDFDocumentProxy } from 'pdfjs-dist/types/src/display/api';
declare const DocumentContext: React.Context<DocumentContextType>;
interface Props extends PropsWithChildren, LoadPDFOptions {
    src?: RPSrc;
    characterMap?: CharacterMap;
    onLoaded?: (pdfDocument: PDFDocumentProxy) => void;
}
export declare const DocumentProvider: FC<Props>;
export declare const useDocumentContext: () => DocumentContextType;
export default DocumentContext;
