import { default as React } from 'react';
import { ViewportProps } from '../utils/types';
type Breakpoint = 'xs' | 'sm' | 'md' | 'lg' | 'xl' | '2xl';
type Orientation = 'portrait' | 'landscape';
interface Breakpoints {
    [key: string]: number;
}
interface ViewportState {
    width: number;
    height: number;
    isMobile: boolean;
    currentBreakpoint: Breakpoint;
    orientation: Orientation;
}
interface ViewportContextType extends ViewportState {
    breakpoints: Breakpoints;
    isBreakpoint: (breakpoint: Breakpoint) => boolean;
    isMobileDevice: boolean;
    isPortrait: boolean;
    isLandscape: boolean;
    isSmallScreen: boolean;
}
interface ViewportProviderProps extends ViewportProps {
    children: React.ReactNode;
}
export declare const ViewportProvider: React.FC<ViewportProviderProps>;
export declare const useViewportContext: () => ViewportContextType;
export {};
