import { FC, PropsWithChildren } from 'react';
import { VariableSizeGrid } from 'react-window';
interface ContextType {
    virtualScrollRef?: VariableSizeGrid;
    getVirtualScrollRef: (element: VariableSizeGrid) => void;
    pageScrollElementRef?: HTMLDivElement;
    getPageScrollElementRef: (element: HTMLDivElement) => void;
    virtualScrollableElementRef?: HTMLDivElement;
    getVirtualScrollableElementRef: (element: HTMLDivElement) => void;
    scrollPosition: {
        scrollTop: number;
        scrollLeft: number;
    };
    setScrollPosition: (position: {
        scrollTop: number;
        scrollLeft: number;
    }) => void;
    totalInnerDimensions: {
        height: number;
        width: number;
    };
    setTotalInnerDimensions: (dimensions: {
        height: number;
        width: number;
    }) => void;
}
export declare const VirtualScrollContext: import('react').Context<ContextType>;
export declare const useVirtualScrollContext: () => ContextType;
export declare const VirtualScrollProvider: FC<PropsWithChildren>;
export {};
